tg-summary: the last of the great speed-ups
[topgit/pro.git] / tg.sh
blob19a8992a972847ecaa2be2cf3475c8f399472304
1 #!/bin/sh
2 # TopGit - A different patch queue manager
3 # Copyright (C) 2008 Petr Baudis <pasky@suse.cz>
4 # Copyright (C) 2014-2017 Kyle J. McKay <mackyle@gmail.com>
5 # All rights reserved.
6 # GPLv2
8 TG_VERSION=0.19.8
10 # Update in Makefile if you add any code that requires a newer version of git
11 GIT_MINIMUM_VERSION="@mingitver@"
13 ## SHA-1 pattern
15 octet='[0-9a-f][0-9a-f]'
16 octet4="$octet$octet$octet$octet"
17 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
18 octet20="$octet4$octet4$octet4$octet4$octet4"
19 nullsha="0000000000000000000000000000000000000000" # :|git mktree|tr 0-9a-f 0
20 mtblob="e69de29bb2d1d6434b8b29ae775ad8c2e48c5391" # :|git hash-object --stdin -w
21 tab=' '
22 lf='
25 ## Auxiliary functions
27 # some ridiculous sh implementations require 'trap ... EXIT' to be executed
28 # OUTSIDE ALL FUNCTIONS to work in a sane fashion. Always trap it and eval
29 # "${TRAPEXIT_:-exit}" as a substitute.
30 trapexit_()
32 EXITCODE_=${1:-$?}
33 trap - EXIT
34 eval "${TRAPEXIT_:-exit $EXITCODE_}"
35 exit $EXITCODE_
37 trap 'trapexit_ $?' EXIT
39 # unset that ignores error code that shouldn't be produced according to POSIX
40 unset_()
42 { unset "$@"; } >/dev/null 2>&1 || :
45 # Preserves current $? value while triggering a non-zero set -e exit if active
46 # This works even for shells that sometimes fail to correctly trigger a -e exit
47 check_exit_code()
49 return $?
52 # This is the POSIX equivalent of which
53 cmd_path()
55 { "unset" -f command unset unalias "$1"; } >/dev/null 2>&1 || :
56 { "unalias" -a || unalias -m "*"; } >/dev/null 2>&1 || :
57 command -v "$1"
60 # helper for wrappers
61 # note deliberate use of '(' ... ')' rather than '{' ... '}'
62 exec_lc_all_c()
64 { "unset" -f "$1" || :; } >/dev/null 2>&1 &&
65 shift &&
66 LC_ALL="C" &&
67 export LC_ALL &&
68 exec "$@"
71 # These tools work better for us with LC_ALL=C and by using these little
72 # convenience functions LC_ALL=C does not have to appear in the code but
73 # any Git translations will still appear for Git commands
74 awk() { exec_lc_all_c awk @AWK_PATH@ "$@"; }
75 cat() { exec_lc_all_c cat cat "$@"; }
76 cut() { exec_lc_all_c cut cut "$@"; }
77 find() { exec_lc_all_c find find "$@"; }
78 grep() { exec_lc_all_c grep grep "$@"; }
79 join() { exec_lc_all_c join join "$@"; }
80 paste() { exec_lc_all_c paste paste "$@"; }
81 sed() { exec_lc_all_c sed sed "$@"; }
82 sort() { exec_lc_all_c sort sort "$@"; }
83 tr() { exec_lc_all_c tr tr "$@"; }
84 wc() { exec_lc_all_c wc wc "$@"; }
85 xargs() { exec_lc_all_c xargs xargs "$@"; }
87 # Output arguments without any possible interpretation
88 # (Avoid misinterpretation of '\' characters or leading "-n", "-E" or "-e")
89 echol()
91 printf '%s\n' "$*"
94 info()
96 echol "${TG_RECURSIVE}${tgname:-tg}: $*"
99 warn()
101 info "warning: $*" >&2
104 err()
106 info "error: $*" >&2
109 fatal()
111 info "fatal: $*" >&2
114 die()
116 fatal "$@"
117 exit 1
120 # shift off first arg then return "$*" properly quoted in single-quotes
121 # if $1 was '' output goes to stdout otherwise it's assigned to $1
122 # the final \n, if any, is omitted from the result but any others are included
123 v_quotearg()
125 _quotearg_v="$1"
126 shift
127 set -- "$_quotearg_v" \
128 "sed \"s/'/'\\\\\\''/g;1s/^/'/;\\\$s/\\\$/'/;s/'''/'/g;1s/^''\\(.\\)/\\1/\"" "$*"
129 unset_ _quotearg_v
130 if [ -z "$3" ]; then
131 if [ -z "$1" ]; then
132 echo "''"
133 else
134 eval "$1=\"''\""
136 else
137 if [ -z "$1" ]; then
138 printf "%s$4" "$3" | eval "$2"
139 else
140 eval "$1="'"$(printf "%s$4" "$3" | eval "$2")"'
145 # same as v_quotearg except there's no extra $1 so output always goes to stdout
146 quotearg()
148 v_quotearg '' "$@"
151 vcmp()
153 # Compare $1 to $3 each of which must match ^[^0-9]*\d*(\.\d*)*.*$
154 # where only the "\d*" parts in the regex participate in the comparison
155 # Since EVERY string matches that regex this function is easy to use
156 # An empty string ('') for $1 or $3 or any "\d*" part is treated as 0
157 # $2 is a compare op '<', '<=', '=', '==', '!=', '>=', '>'
158 # Return code is 0 for true, 1 for false (or unknown compare op)
159 # There is NO difference in behavior between '=' and '=='
160 # Note that "vcmp 1.8 == 1.8.0.0.0.0" correctly returns 0
161 set -- "$1" "$2" "$3" "${1%%[0-9]*}" "${3%%[0-9]*}"
162 set -- "${1#"$4"}" "$2" "${3#"$5"}"
163 set -- "${1%%[!0-9.]*}" "$2" "${3%%[!0-9.]*}"
164 while
165 vcmp_a_="${1%%.*}"
166 vcmp_b_="${3%%.*}"
167 [ "z$vcmp_a_" != "z" -o "z$vcmp_b_" != "z" ]
169 if [ "${vcmp_a_:-0}" -lt "${vcmp_b_:-0}" ]; then
170 unset_ vcmp_a_ vcmp_b_
171 case "$2" in "<"|"<="|"!=") return 0; esac
172 return 1
173 elif [ "${vcmp_a_:-0}" -gt "${vcmp_b_:-0}" ]; then
174 unset_ vcmp_a_ vcmp_b_
175 case "$2" in ">"|">="|"!=") return 0; esac
176 return 1;
178 vcmp_a_="${1#$vcmp_a_}"
179 vcmp_b_="${3#$vcmp_b_}"
180 set -- "${vcmp_a_#.}" "$2" "${vcmp_b_#.}"
181 done
182 unset_ vcmp_a_ vcmp_b_
183 case "$2" in "="|"=="|"<="|">=") return 0; esac
184 return 1
187 precheck() {
188 if ! git_version="$(git version)"; then
189 die "'git version' failed"
191 case "$git_version" in [Gg]"it version "*);;*)
192 die "'git version' output does not start with 'git version '"
193 esac
195 vcmp "$git_version" '>=' "$GIT_MINIMUM_VERSION" ||
196 die "git version >= $GIT_MINIMUM_VERSION required but found $git_version instead"
199 case "$1" in version|--version|-V)
200 echo "TopGit version $TG_VERSION"
201 exit 0
202 esac
204 [ $# -eq 1 ] && [ "$1" = "--make-empty-blob" ] || precheck
205 [ $# -ne 1 ] || [ "$1" != "precheck" ] || exit 0
207 cat_depsmsg_internal()
209 _rev="$(ref_exists_rev "refs/heads/$1")" || return 0
210 if [ -s "$tg_cache_dir/refs/heads/$1/.$2" ]; then
211 if read _rev_match && [ "$_rev" = "$_rev_match" ]; then
212 _line=
213 while IFS= read -r _line || [ -n "$_line" ]; do
214 printf '%s\n' "$_line"
215 done
216 return 0
217 fi <"$tg_cache_dir/refs/heads/$1/.$2"
219 [ -d "$tg_cache_dir/refs/heads/$1" ] || mkdir -p "$tg_cache_dir/refs/heads/$1" 2>/dev/null || :
220 if [ -d "$tg_cache_dir/refs/heads/$1" ]; then
221 printf '%s\n' "$_rev" >"$tg_cache_dir/refs/heads/$1/.$2"
222 _line=
223 git cat-file blob "$_rev:.$2" 2>/dev/null |
224 while IFS= read -r _line || [ -n "$_line" ]; do
225 printf '%s\n' "$_line" >&3
226 printf '%s\n' "$_line"
227 done 3>>"$tg_cache_dir/refs/heads/$1/.$2"
228 else
229 git cat-file blob "$_rev:.$2" 2>/dev/null
233 # cat_deps BRANCHNAME
234 # Caches result
235 cat_deps()
237 cat_depsmsg_internal "$1" topdeps
240 # cat_msg BRANCHNAME
241 # Caches result
242 cat_msg()
244 cat_depsmsg_internal "$1" topmsg
247 # cat_file TOPIC:PATH [FROM]
248 # cat the file PATH from branch TOPIC when FROM is empty.
249 # FROM can be -i or -w, than the file will be from the index or worktree,
250 # respectively. The caller should than ensure that HEAD is TOPIC, to make sense.
251 cat_file()
253 path="$1"
254 case "$2" in
256 cat "$root_dir/${path#*:}"
259 # ':file' means cat from index
260 git cat-file blob ":${path#*:}" 2>/dev/null
263 case "$path" in
264 refs/heads/*:.topdeps)
265 _temp="${path%:.topdeps}"
266 cat_deps "${_temp#refs/heads/}"
268 refs/heads/*:.topmsg)
269 _temp="${path%:.topmsg}"
270 cat_msg "${_temp#refs/heads/}"
273 git cat-file blob "$path" 2>/dev/null
275 esac
278 die "Wrong argument to cat_file: '$2'"
280 esac
283 # if use_alt_temp_odb and tg_use_alt_odb are true try to write the object(s)
284 # into the temporary alt odb area instead of the usual location
285 git_temp_alt_odb_cmd()
287 if [ -n "$use_alt_temp_odb" ] && [ -n "$tg_use_alt_odb" ] &&
288 [ -n "$TG_OBJECT_DIRECTORY" ] &&
289 [ -f "$TG_OBJECT_DIRECTORY/info/alternates" ]; then
291 GIT_ALTERNATE_OBJECT_DIRECTORIES="$TG_PRESERVED_ALTERNATES"
292 GIT_OBJECT_DIRECTORY="$TG_OBJECT_DIRECTORY"
293 unset_ TG_OBJECT_DIRECTORY TG_PRESERVED_ALTERNATES
294 export GIT_ALTERNATE_OBJECT_DIRECTORIES GIT_OBJECT_DIRECTORY
295 git "$@"
297 else
298 git "$@"
302 git_write_tree() { git_temp_alt_odb_cmd write-tree "$@"; }
303 git_mktree() { git_temp_alt_odb_cmd mktree "$@"; }
305 make_mtblob() {
306 use_alt_temp_odb=1
307 tg_use_alt_odb=1
308 git_temp_alt_odb_cmd hash-object -t blob -w --stdin </dev/null >/dev/null 2>&1
310 # short-circuit this for speed
311 [ $# -eq 1 ] && [ "$1" = "--make-empty-blob" ] && { make_mtblob || :; exit 0; }
313 # get tree for the committed topic
314 get_tree_()
316 echo "refs/heads/$1"
319 # get tree for the base
320 get_tree_b()
322 echo "refs/$topbases/$1"
325 # get tree for the index
326 get_tree_i()
328 git_write_tree
331 # get tree for the worktree
332 get_tree_w()
334 i_tree=$(git_write_tree)
336 # the file for --index-output needs to sit next to the
337 # current index file
338 cd "$root_dir"
339 : ${GIT_INDEX_FILE:="$git_dir/index"}
340 TMP_INDEX="$(mktemp "${GIT_INDEX_FILE}-tg.XXXXXX")"
341 git read-tree -m $i_tree --index-output="$TMP_INDEX" &&
342 GIT_INDEX_FILE="$TMP_INDEX" &&
343 export GIT_INDEX_FILE &&
344 git diff --name-only -z HEAD |
345 git update-index -z --add --remove --stdin &&
346 git_write_tree &&
347 rm -f "$TMP_INDEX"
351 # get tree for arbitrary ref
352 get_tree_r()
354 echo "$1"
357 # strip_ref "$(git symbolic-ref HEAD)"
358 # Output will have a leading refs/heads/ or refs/$topbases/ stripped if present
359 strip_ref()
361 case "$1" in
362 refs/"$topbases"/*)
363 echol "${1#refs/$topbases/}"
365 refs/heads/*)
366 echol "${1#refs/heads/}"
369 echol "$1"
370 esac
373 # pretty_tree [-t] NAME [-b | -i | -w | -r]
374 # Output tree ID of a cleaned-up tree without tg's artifacts.
375 # NAME will be ignored for -i and -w, but needs to be present
376 # With -r NAME must be a full ref name to a treeish (it's used as-is)
377 # If -t is used the tree is written into the alternate temporary objects area
378 pretty_tree()
380 use_alt_temp_odb=
381 [ "$1" != "-t" ] || { shift; use_alt_temp_odb=1; }
382 name="$1"
383 source="${2#?}"
384 git ls-tree --full-tree "$(get_tree_$source "$name")" |
385 sed -ne '/ \.top.*$/!p' |
386 git_mktree
389 # return an empty-tree root commit -- date is either passed in or current
390 # If passed in "$*" must be epochsecs followed by optional hhmm offset (+0000 default)
391 # An invalid secs causes the current date to be used, an invalid zone offset
392 # causes +0000 to be used
393 make_empty_commit()
395 # the empty tree is guaranteed to always be there even in a repo with
396 # zero objects, but for completeness we force it to exist as a real object
397 SECS=
398 read -r SECS ZONE JUNK <<-EOT || :
401 case "$SECS" in *[!0-9]*) SECS=; esac
402 if [ -z "$SECS" ]; then
403 MTDATE="$(date '+%s %z')"
404 else
405 case "$ZONE" in
406 -[01][0-9][0-5][0-9]|+[01][0-9][0-5][0-9])
408 [01][0-9][0-5][0-9])
409 ZONE="+$ZONE"
412 ZONE="+0000"
413 esac
414 MTDATE="$SECS $ZONE"
416 EMPTYID="- <-> $MTDATE"
417 EMPTYTREE="$(git hash-object -t tree -w --stdin < /dev/null)"
418 printf '%s\n' "tree $EMPTYTREE" "author $EMPTYID" "committer $EMPTYID" '' |
419 git hash-object -t commit -w --stdin
422 # standard input is a diff
423 # standard output is the "+" lines with leading "+ " removed
424 # beware that old lines followed by the dreaded '\ No newline at end of file'
425 # will appear to be new lines if lines are added after them
426 # the git diff --ignore-space-at-eol option can be used to prevent this
427 diff_added_lines()
429 awk '
430 BEGIN { in_hunk = 0; }
431 /^@@ / { in_hunk = 1; }
432 /^\+/ { if (in_hunk == 1) printf("%s\n", substr($0, 2)); }
433 !/^\\ No newline at end of file/ &&
434 /^[^@ +-]/ { in_hunk = 0; }
438 # $1 is name of new branch to create locally if all of these are true:
439 # a) exists as a remote TopGit branch for "$base_remote"
440 # b) the branch "name" does not have any invalid characters in it
441 # c) neither of the two branch refs (branch or base) exist locally
442 # returns success only if a new local branch was created (and dumps message)
443 auto_create_local_remote()
445 case "$1" in ""|*[" $tab$lf~^:\\*?["]*|.*|*/.*|*.|*./|/*|*/|*//*) return 1; esac
446 [ -n "$base_remote" ] &&
447 git update-ref --stdin <<-EOT >/dev/null 2>&1 &&
448 verify refs/remotes/$base_remote/${topbases#heads/}/$1 refs/remotes/$base_remote/${topbases#heads/}/$1
449 verify refs/remotes/$base_remote/$1 refs/remotes/$base_remote/$1
450 create refs/$topbases/$1 refs/remotes/$base_remote/${topbases#heads/}/$1^0
451 create refs/heads/$1 refs/remotes/$base_remote/$1^0
453 { init_reflog "refs/$topbases/$1" || :; } &&
454 info "topic branch '$1' automatically set up from remote '$base_remote'"
457 # setup_hook NAME
458 setup_hook()
460 setup_git_dir_is_bare
461 [ -z "$git_dir_is_bare" ] || return 0
462 tgname="${0##*/}"
463 hook_call="\"\$(\"$tgname\" --hooks-path)\"/$1 \"\$@\""
464 if [ -f "$git_hooks_dir/$1" ] && grep -Fq "$hook_call" "$git_hooks_dir/$1"; then
465 # Another job well done!
466 return
468 # Prepare incantation
469 hook_chain=
470 if [ -s "$git_hooks_dir/$1" -a -x "$git_hooks_dir/$1" ]; then
471 hook_call="$hook_call"' || exit $?'
472 if [ -L "$git_hooks_dir/$1" ] || ! sed -n 1p <"$git_hooks_dir/$1" | grep -Fqx "#!@SHELL_PATH@"; then
473 chain_num=
474 while [ -e "$git_hooks_dir/$1-chain$chain_num" ]; do
475 chain_num=$(( $chain_num + 1 ))
476 done
477 mv -f "$git_hooks_dir/$1" "$git_hooks_dir/$1-chain$chain_num"
478 hook_chain=1
480 else
481 hook_call="exec $hook_call"
482 [ -d "$git_hooks_dir" ] || mkdir -p "$git_hooks_dir" || :
484 # Don't call hook if tg is not installed
485 hook_call="if command -v \"$tgname\" >/dev/null 2>&1; then $hook_call; fi"
486 # Insert call into the hook
488 echol "#!@SHELL_PATH@"
489 echol "$hook_call"
490 if [ -n "$hook_chain" ]; then
491 echol "exec \"\$0-chain$chain_num\" \"\$@\""
492 else
493 [ ! -s "$git_hooks_dir/$1" ] || cat "$git_hooks_dir/$1"
495 } >"$git_hooks_dir/$1+"
496 chmod a+x "$git_hooks_dir/$1+"
497 mv "$git_hooks_dir/$1+" "$git_hooks_dir/$1"
500 # setup_ours (no arguments)
501 setup_ours()
503 setup_git_dir_is_bare
504 [ -z "$git_dir_is_bare" ] || return 0
505 if [ ! -s "$git_common_dir/info/attributes" ] || ! grep -q topmsg "$git_common_dir/info/attributes"; then
506 [ -d "$git_common_dir/info" ] || mkdir "$git_common_dir/info"
508 echo ".topmsg merge=ours"
509 echo ".topdeps merge=ours"
510 } >>"$git_common_dir/info/attributes"
512 if ! git config merge.ours.driver >/dev/null; then
513 git config merge.ours.name '"always keep ours" merge driver'
514 git config merge.ours.driver 'touch %A'
518 # measure_branch NAME [BASE] [EXTRAHEAD...]
519 measure_branch()
521 _bname="$1"; _base="$2"
522 shift; shift
523 [ -n "$_base" ] || _base="refs/$topbases/$(strip_ref "$_bname")"
524 # The caller should've verified $name is valid
525 _commits="$(git rev-list --count "$_bname" "$@" ^"$_base" --)"
526 _nmcommits="$(git rev-list --count --no-merges "$_bname" "$@" ^"$_base" --)"
527 if [ $_commits -ne 1 ]; then
528 _suffix="commits"
529 else
530 _suffix="commit"
532 echo "$_commits/$_nmcommits $_suffix"
535 # true if $1 is contained by (or the same as) $2
536 # this is never slower than merge-base --is-ancestor and is often slightly faster
537 contained_by()
539 [ "$(git rev-list --count --max-count=1 "$1" --not "$2" --)" = "0" ]
542 # branch_contains B1 B2
543 # Whether B1 is a superset of B2.
544 branch_contains()
546 _revb1="$(ref_exists_rev "$1")" || return 0
547 _revb2="$(ref_exists_rev "$2")" || return 0
548 if [ -s "$tg_cache_dir/$1/.bc/$2/.d" ]; then
549 if read _result _rev_matchb1 _rev_matchb2 &&
550 [ "$_revb1" = "$_rev_matchb1" -a "$_revb2" = "$_rev_matchb2" ]; then
551 return $_result
552 fi <"$tg_cache_dir/$1/.bc/$2/.d"
554 [ -d "$tg_cache_dir/$1/.bc/$2" ] || mkdir -p "$tg_cache_dir/$1/.bc/$2" 2>/dev/null || :
555 _result=0
556 contained_by "$_revb2" "$_revb1" || _result=1
557 if [ -d "$tg_cache_dir/$1/.bc/$2" ]; then
558 echo "$_result" "$_revb1" "$_revb2" >"$tg_cache_dir/$1/.bc/$2/.d"
560 return $_result
563 create_ref_dirs()
565 [ ! -s "$tg_tmp_dir/tg~ref-dirs-created" -a -s "$tg_ref_cache" ] || return 0
566 mkdir -p "$tg_tmp_dir/cached/refs"
567 awk '{x = $1; sub(/^refs\//, "", x); if (x != "") print x}' <"$tg_ref_cache" | tr '\n' '\0' | {
568 cd "$tg_tmp_dir/cached/refs" &&
569 xargs -0 mkdir -p
571 awk -v p="$tg_tmp_dir/cached/" '
572 NF == 2 &&
573 $1 ~ /^refs\/./ &&
574 $2 ~ /^[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]+$/ {
575 fn = p $1 "/.ref"
576 print "0 " $2 >fn
577 close(fn)
579 ' <"$tg_ref_cache"
580 echo 1 >"$tg_tmp_dir/tg~ref-dirs-created"
583 # If the first argument is non-empty, stores "1" there if this call created the cache
584 v_create_ref_cache()
586 [ -n "$tg_ref_cache" -a ! -s "$tg_ref_cache" ] || return 0
587 _remotespec=
588 [ -z "$base_remote" ] || _remotespec="refs/remotes/$base_remote"
589 [ -z "$1" ] || eval "$1=1"
590 git for-each-ref --format='%(refname) %(objectname)' \
591 refs/heads "refs/$topbases" $_remotespec >"$tg_ref_cache"
592 create_ref_dirs
595 remove_ref_cache()
597 [ -n "$tg_ref_cache" -a -s "$tg_ref_cache" ] || return 0
598 >"$tg_ref_cache"
599 >"$tg_ref_cache_br"
600 >"$tg_ref_cache_rbr"
601 >"$tg_ref_cache_ann"
602 >"$tg_ref_cache_dep"
605 # setting tg_ref_cache_only to non-empty will force non-$tg_ref_cache lookups to fail
606 rev_parse()
608 if [ -n "$tg_ref_cache" -a -s "$tg_ref_cache" ]; then
609 awk -v r="$1" 'BEGIN {e=1}; $1 == r {print $2; e=0; exit}; END {exit e}' <"$tg_ref_cache"
610 else
611 [ -z "$tg_ref_cache_only" ] || return 1
612 git rev-parse --quiet --verify "$1^0" -- 2>/dev/null
616 # ref_exists_rev REF
617 # Whether REF is a valid ref name
618 # REF must be fully qualified and start with refs/heads/, refs/$topbases/
619 # or, if $base_remote is set, refs/remotes/$base_remote/
620 # Caches result if $tg_read_only and outputs HASH on success
621 ref_exists_rev()
623 case "$1" in
624 refs/*)
626 $octet20)
627 printf '%s' "$1"
628 return;;
630 die "ref_exists_rev requires fully-qualified ref name (given: $1)"
631 esac
632 [ -n "$tg_read_only" ] || { git rev-parse --quiet --verify "$1^0" -- 2>/dev/null; return; }
633 _result=
634 _result_rev=
635 { read -r _result _result_rev <"$tg_tmp_dir/cached/$1/.ref"; } 2>/dev/null || :
636 [ -z "$_result" ] || { printf '%s' "$_result_rev"; return $_result; }
637 _result_rev="$(rev_parse "$1")"
638 _result=$?
639 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null
640 [ ! -d "$tg_tmp_dir/cached/$1" ] ||
641 echo $_result $_result_rev >"$tg_tmp_dir/cached/$1/.ref" 2>/dev/null || :
642 printf '%s' "$_result_rev"
643 return $_result
646 # Same as ref_exists_rev but output is abbreviated hash
647 # Optional second argument defaults to --short but may be any --short=.../--no-short option
648 ref_exists_rev_short()
650 case "$1" in
651 refs/*)
653 $octet20)
656 die "ref_exists_rev_short requires fully-qualified ref name"
657 esac
658 [ -n "$tg_read_only" ] || { git rev-parse --quiet --verify ${2:---short} "$1^0" -- 2>/dev/null; return; }
659 _result=
660 _result_rev=
661 { read -r _result _result_rev <"$tg_tmp_dir/cached/$1/.rfs"; } 2>/dev/null || :
662 [ -z "$_result" ] || { printf '%s' "$_result_rev"; return $_result; }
663 _result_rev="$(rev_parse "$1")"
664 _result=$?
665 if [ $_result -eq 0 ]; then
666 _result_rev="$(git rev-parse --verify ${2:---short} --quiet "$_result_rev^0" --)"
667 _result=$?
669 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null
670 [ ! -d "$tg_tmp_dir/cached/$1" ] ||
671 echo $_result $_result_rev >"$tg_tmp_dir/cached/$1/.rfs" 2>/dev/null || :
672 printf '%s' "$_result_rev"
673 return $_result
676 # ref_exists REF
677 # Whether REF is a valid ref name
678 # REF must be fully qualified and start with refs/heads/, refs/$topbases/
679 # or, if $base_remote is set, refs/remotes/$base_remote/
680 # Caches result
681 ref_exists()
683 ref_exists_rev "$1" >/dev/null
686 # rev_parse_tree REF
687 # Runs git rev-parse REF^{tree}
688 # Caches result if $tg_read_only
689 rev_parse_tree()
691 [ -n "$tg_read_only" ] || { git rev-parse --verify "$1^{tree}" -- 2>/dev/null; return; }
692 if [ -f "$tg_tmp_dir/cached/$1/.rpt" ]; then
693 if IFS= read -r _result <"$tg_tmp_dir/cached/$1/.rpt"; then
694 printf '%s\n' "$_result"
695 return 0
697 return 1
699 [ -d "$tg_tmp_dir/cached/$1" ] || mkdir -p "$tg_tmp_dir/cached/$1" 2>/dev/null || :
700 if [ -d "$tg_tmp_dir/cached/$1" ]; then
701 git rev-parse --verify "$1^{tree}" -- >"$tg_tmp_dir/cached/$1/.rpt" 2>/dev/null || :
702 if IFS= read -r _result <"$tg_tmp_dir/cached/$1/.rpt"; then
703 printf '%s\n' "$_result"
704 return 0
706 return 1
708 git rev-parse --verify "$1^{tree}" -- 2>/dev/null
711 # has_remote BRANCH
712 # Whether BRANCH has a remote equivalent (accepts ${topbases#heads/}/ too)
713 has_remote()
715 [ -n "$base_remote" ] && ref_exists "refs/remotes/$base_remote/$1"
718 # Return the verified TopGit branch name for "$2" in "$1" or die with an error.
719 # If -z "$1" still set return code but do not return result
720 # As a convenience, if HEAD or @ is given and HEAD is a symbolic ref to
721 # refs/heads/... then ... will be verified instead.
722 # if "$3" = "-f" (for fail) then return an error rather than dying.
723 v_verify_topgit_branch()
725 if [ "$2" = "HEAD" ] || [ "$2" = "@" ]; then
726 _verifyname="$(git symbolic-ref HEAD 2>/dev/null)" || :
727 [ -n "$_verifyname" -o "$3" = "-f" ] || die "HEAD is not a symbolic ref"
728 case "$_verifyname" in refs/"$topbases"/*|refs/heads/*);;*)
729 [ "$3" != "-f" ] || return 1
730 die "HEAD is not a symbolic ref to the refs/heads namespace"
731 esac
732 set -- "$1" "$_verifyname" "$3"
734 case "$2" in
735 refs/"$topbases"/*)
736 _verifyname="${2#refs/$topbases/}"
738 refs/heads/*)
739 _verifyname="${2#refs/heads/}"
742 _verifyname="$2"
744 esac
745 if ! ref_exists "refs/heads/$_verifyname"; then
746 [ "$3" != "-f" ] || return 1
747 die "no such branch: $_verifyname"
749 if ! ref_exists "refs/$topbases/$_verifyname"; then
750 [ "$3" != "-f" ] || return 1
751 die "not a TopGit-controlled branch: $_verifyname"
753 [ -z "$1" ] || eval "$1="'"$_verifyname"'
756 # Return the verified TopGit branch name or die with an error.
757 # As a convenience, if HEAD or @ is given and HEAD is a symbolic ref to
758 # refs/heads/... then ... will be verified instead.
759 # if "$2" = "-f" (for fail) then return an error rather than dying.
760 verify_topgit_branch()
762 v_verify_topgit_branch _verifyname "$@" || return
763 printf '%s' "$_verifyname"
766 # Caches result
767 # $1 = branch name (i.e. "t/foo/bar")
768 # $2 = optional result of rev-parse "refs/heads/$1"
769 # $3 = optional result of rev-parse "refs/$topbases/$1"
770 branch_annihilated()
772 _branch_name="$1"
773 _rev="${2:-$(ref_exists_rev "refs/heads/$_branch_name")}"
774 _rev_base="${3:-$(ref_exists_rev "refs/$topbases/$_branch_name")}"
776 _result=
777 _result_rev=
778 _result_rev_base=
779 { read -r _result _result_rev _result_rev_base <"$tg_cache_dir/refs/heads/$_branch_name/.ann"; } 2>/dev/null || :
780 [ -z "$_result" -o "$_result_rev" != "$_rev" -o "$_result_rev_base" != "$_rev_base" ] || return $_result
782 # use the merge base in case the base is ahead.
783 mb="$(git merge-base "$_rev_base" "$_rev" 2>/dev/null)"
785 test -z "$mb" || test "$(rev_parse_tree "$mb")" = "$(rev_parse_tree "$_rev")"
786 _result=$?
787 [ -d "$tg_cache_dir/refs/heads/$_branch_name" ] || mkdir -p "$tg_cache_dir/refs/heads/$_branch_name" 2>/dev/null
788 [ ! -d "$tg_cache_dir/refs/heads/$_branch_name" ] ||
789 echo $_result $_rev $_rev_base >"$tg_cache_dir/refs/heads/$_branch_name/.ann" 2>/dev/null || :
790 return $_result
793 non_annihilated_branches()
795 refscacheopt="${TG_DEBUG:+-p=\"\$tg_ref_cache.pre\" }"
796 if [ -n "$tg_read_only" ] && [ -n "$tg_ref_cache" ] && [ -s "$tg_ref_cache" ]; then
797 refscacheopt="$refscacheopt"'-r="$tg_ref_cache" "refs/$topbases"'
799 eval run_awk_topgit_branches -n "$refscacheopt" '"refs/$topbases" "$@"'
802 # Make sure our tree is clean
803 # if optional "$1" given also verify that a checkout to "$1" would succeed
804 ensure_clean_tree()
806 check_status
807 [ -z "$tg_state$git_state" ] || { do_status; exit 1; }
808 git update-index --ignore-submodules --refresh ||
809 die "the working directory has uncommitted changes (see above) - first commit or reset them"
810 [ -z "$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)" ] ||
811 die "the index has uncommited changes"
812 [ -z "$1" ] || git read-tree -n -u -m "$1" ||
813 die "git checkout \"$1\" would fail"
816 # Make sure .topdeps and .topmsg are "clean"
817 # They are considered "clean" if each is identical in worktree, index and HEAD
818 # With "-u" as the argument skip the HEAD check (-u => unborn)
819 # untracked .topdeps and/or .topmsg files are always considered "dirty" as well
820 # with -u them just existing constitutes "dirty"
821 ensure_clean_topfiles()
823 _dirtw=0
824 _dirti=0
825 _dirtu=0
826 _check="$(git diff-files --ignore-submodules --name-only -- :/.topdeps :/.topmsg)" &&
827 [ -z "$_check" ] || _dirtw=1
828 if [ "$1" != "-u" ]; then
829 _check="$(git diff-index --cached --ignore-submodules --name-only HEAD -- :/.topdeps :/.topmsg)" &&
830 [ -z "$_check" ] || _dirti=1
832 if [ "$_dirti$_dirtw" = "00" ]; then
833 v_get_show_cdup
834 if [ -e "${git_cdup_result}.topdeps" ] || [ -e "${git_cdup_result}.topmsg" ]; then
835 [ "$1" != "-u" ] &&
836 _check="$(git status --porcelain --ignored --untracked-files --ignore-submodules -- :/.topdeps :/.topmsg)" &&
837 [ -z "$_check" ] || _dirtu=1
840 if [ "$_dirtu$_dirti$_dirtw" != "000" ]; then
841 git status --ignored --untracked-files --ignore-submodules -- :/.topdeps :/.topmsg || :
842 case "$_dirtu$_dirti$_dirtw" in
843 001) die "the working directory has uncommitted changes (see above) - first commit or reset them";;
844 010) die "the index has uncommited changes (see above)";;
845 011) die "the working directory and index have uncommitted changes (see above) - first commit or reset them";;
846 100) die "the working directory has untracked files that would be overwritten (see above)";;
847 esac
851 # is_sha1 REF
852 # Whether REF is a SHA1 (compared to a symbolic name).
853 is_sha1()
855 case "$1" in $octet20) return 0;; esac
856 return 1
859 # navigate_deps <run_awk_topgit_navigate options and arguments>
860 # all options and arguments are passed through to run_awk_topgit_navigate
861 # except for a leading -td= option, if any, which is picked off for deps
862 # after arranging to feed it a suitable deps list
863 navigate_deps()
865 dogfer=
866 dorad=1
867 userc=
868 tmpdep=
869 ratd_opts="${TG_DEBUG:+-p=\"\$tg_ref_cache.pre\" }"
870 ratn_opts=
871 if [ -n "$tg_read_only" ] && [ -n "$tg_ref_cache" ]; then
872 userc=1
873 tmprfs="$tg_ref_cache"
874 tmptgbr="$tg_ref_cache_br"
875 tmpann="$tg_ref_cache_ann"
876 tmpdep="$tg_ref_cache_dep"
877 [ -s "$tg_ref_cache" ] || dogfer=1
878 [ -n "$dogfer" ] || ! [ -s "$tmptgbr" ] || ! [ -f "$tmpann" ] || ! [ -s "$tmpdep" ] || dorad=
879 else
880 ratd_opts="${ratd_opts}-rmr"
881 ratn_opts="-rma -rmb"
882 tmprfs="$tg_tmp_dir/refs.$$"
883 tmpann="$tg_tmp_dir/ann.$$"
884 tmptgbr="$tg_tmp_dir/tgbr.$$"
885 dogfer=1
887 refpats="\"refs/heads\" \"refs/\$topbases\""
888 [ -z "$base_remote" ] || refpats="$refpats \"refs/remotes/\$base_remote\""
889 [ -z "$dogfer" ] ||
890 eval git for-each-ref '--format="%(refname) %(objectname)"' "$refpats" >"$tmprfs"
891 depscmd="run_awk_topgit_deps $ratd_opts"
892 case "$1" in -td=*)
893 userc=
894 depscmd="$depscmd $1"
895 shift
896 esac
897 depscmd="$depscmd"' -a="$tmpann" -b="$tmptgbr" -r="$tmprfs" -s "refs/$topbases"'
898 if [ -n "$userc" ]; then
899 if [ -n "$dorad" ]; then
900 eval "$depscmd" >"$tmpdep"
902 depscmd='<"$tmpdep" '
903 else
904 depscmd="$depscmd |"
906 eval "$depscmd" run_awk_topgit_navigate '-a="$tmpann" -b="$tmptgbr"' "$ratn_opts" '"$@"'
909 # recurse_deps_internal NAME [BRANCHPATH...]
910 # get recursive list of dependencies with leading 0 if branch exists 1 if missing
911 # followed by a 1 if the branch is "tgish" (2 if it also has a remote); 0 if not
912 # followed by a 0 for a non-leaf, 1 for a leaf or 2 for annihilated tgish
913 # (but missing and remotes are always "0")
914 # followed by a 0 for no excess visits or a positive number of excess visits
915 # then the branch name followed by its depedency chain (which might be empty)
916 # An output line might look like this:
917 # 0 1 1 0 t/foo/leaf t/foo/int t/stage
918 # If no_remotes is non-empty, exclude remotes
919 # If recurse_preorder is non-empty, do a preorder rather than postorder traversal
920 # If with_top_level is non-empty, include the top-level that's normally omitted
921 # any branch names in the space-separated recurse_deps_exclude variable
922 # are skipped (along with their dependencies)
923 recurse_deps_internal()
925 case " $recurse_deps_exclude " in *" $1 "*) return 0; esac
926 ratr_opts="${recurse_preorder:+-f} ${with_top_level:+-s}"
927 dogfer=
928 dorad=1
929 userc=
930 tmpdep=
931 if [ -n "$tg_read_only" ] && [ -n "$tg_ref_cache" ]; then
932 userc=1
933 tmprfs="$tg_ref_cache"
934 tmptgbr="$tg_ref_cache_br"
935 tmpann="$tg_ref_cache_ann"
936 tmpdep="$tg_ref_cache_dep"
937 [ -s "$tg_ref_cache" ] || dogfer=1
938 [ -n "$dogfer" ] || ! [ -s "$tmptgbr" ] || ! [ -f "$tmpann" ] || ! [ -s "$tmpdep" ] || dorad=
939 else
940 ratr_opts="$ratr_opts -rmh -rma -rmb"
941 tmprfs="$tg_tmp_dir/refs.$$"
942 tmpann="$tg_tmp_dir/ann.$$"
943 tmptgbr="$tg_tmp_dir/tgbr.$$"
944 dogfer=1
946 refpats="\"refs/heads\" \"refs/\$topbases\""
947 [ -z "$base_remote" ] || refpats="$refpats \"refs/remotes/\$base_remote\""
948 tmptgrmtbr=
949 dorab=1
950 if [ -z "$no_remotes" ] && [ -n "$base_remote" ]; then
951 if [ -n "$userc" ]; then
952 tmptgrmtbr="$tg_ref_cache_rbr"
953 [ -n "$dogfer" ] || ! [ -s "$tmptgrmtbr" ] || dorab=
954 else
955 tmptgrmtbr="$tg_tmp_dir/tgrmtbr.$$"
956 ratr_opts="$ratr_opts -rmr"
958 ratr_opts="$ratr_opts -r=\"\$tmptgbr\" -u=\"refs/remotes/\$base_remote/\${topbases#heads/}\""
960 [ -z "$dogfer" ] ||
961 eval git for-each-ref '--format="%(refname) %(objectname)"' "$refpats" >"$tmprfs"
962 if [ -n "$tmptgrmtbr" ] && [ -n "$dorab" ]; then
963 run_awk_topgit_branches -n -h="refs/remotes/$base_remote" -r="$tmprfs" \
964 "refs/remotes/$base_remote/${topbases#heads/}" >"$tmptgrmtbr"
966 depscmd="run_awk_topgit_deps${TG_DEBUG:+ -p=\"\$tg_ref_cache.pre\"}"
967 depscmd="$depscmd"' -a="$tmpann" -b="$tmptgbr" -r="$tmprfs" "refs/$topbases"'
968 if [ -n "$userc" ]; then
969 if [ -n "$dorad" ]; then
970 eval "$depscmd" >"$tmpdep"
972 depscmd='<"$tmpdep" '
973 else
974 depscmd="$depscmd |"
976 eval "$depscmd" run_awk_topgit_recurse '-a="$tmpann" -b="$tmptgbr"' \
977 '-c=1 -h="$tmprfs"' "$ratr_opts" '-x="$recurse_deps_exclude"' '"$@"'
980 # do_eval CMD
981 # helper for recurse_deps so that a return statement executed inside CMD
982 # does not return from recurse_deps. This shouldn't be necessary, but it
983 # seems that it actually is.
984 do_eval()
986 eval "$@"
989 # becomes read-only for caching purposes
990 # assigns new value to tg_read_only
991 # become_cacheable/undo_become_cacheable calls may be nested
992 become_cacheable()
994 _old_tg_read_only="$tg_read_only"
995 if [ -z "$tg_read_only" ]; then
996 ! [ -e "$tg_tmp_dir/cached" ] && ! [ -e "$tg_tmp_dir/tg~ref-dirs-created" ] ||
997 rm -rf "$tg_tmp_dir/cached" "$tg_tmp_dir/tg~ref-dirs-created"
998 tg_read_only=1
1000 _my_ref_cache=
1001 v_create_ref_cache _my_ref_cache
1002 _my_ref_cache="${_my_ref_cache:+1}"
1003 tg_read_only="undo${_my_ref_cache:-0}-$_old_tg_read_only"
1006 # restores tg_read_only and ref_cache to state before become_cacheable call
1007 # become_cacheable/undo_bocome_cacheable calls may be nested
1008 undo_become_cacheable()
1010 case "$tg_read_only" in
1011 "undo"[01]"-"*)
1012 _suffix="${tg_read_only#undo?-}"
1013 [ "${tg_read_only%$_suffix}" = "undo0-" ] || remove_ref_cache
1014 tg_read_only="$_suffix"
1015 esac
1018 # just call this, no undo, sets tg_read_only= and removes ref cache and cached results
1019 become_non_cacheable()
1021 remove_ref_cache
1022 tg_read_only=
1023 ! [ -e "$tg_tmp_dir/cached" ] && ! [ -e "$tg_tmp_dir/tg~ref-dirs-created" ] ||
1024 rm -rf "$tg_tmp_dir/cached" "$tg_tmp_dir/tg~ref-dirs-created"
1027 # call this to make sure the current Git repository has an associated work tree
1028 ensure_work_tree()
1030 setup_git_dir_is_bare
1031 [ -n "$git_dir_is_bare" ] || return 0
1032 die "This operation must be run in a work tree"
1035 # call this to make sure Git will not complain about a missing user/email
1036 # result is cached in TG_IDENT_CHECKED and a non-empty value suppresses the check
1037 ensure_ident_available()
1039 [ -z "$TG_IDENT_CHECKED" ] || return 0
1040 git var GIT_AUTHOR_IDENT >/dev/null &&
1041 git var GIT_COMMITTER_IDENT >/dev/null || exit
1042 TG_IDENT_CHECKED=1
1043 export TG_IDENT_CHECKED
1044 return 0
1047 # recurse_deps [-o=<options string>] CMD NAME [BRANCHPATH...]
1048 # Recursively eval CMD on all dependencies of NAME.
1049 # Dependencies are visited in topological order.
1050 # If <options string> is given, it's eval'd into the recurse_deps_internal
1051 # call just before the "--" that's passed just before NAME
1052 # CMD can refer to the following variables:
1054 # _ret starts as 0; CMD can change; will be final return result
1055 # _dep bare branch name or "refs/remotes/..." for a remote base
1056 # _name has $_dep in its .topdeps ("" for top and $with_top_level)
1057 # _depchain 0+ space-separated branch names forming a path to top
1058 # _dep_missing boolean "1" if no such $_dep ref; "" if ref present
1059 # _dep_is_leaf boolean "1" if leaf; "" if not
1060 # _dep_is_tgish boolean "1" if tgish; "" if not (which implies no remote)
1061 # _dep_has_remote boolean "1" if $_dep has_remote; "" if not
1062 # _dep_annihilated boolean "1" if $_dep annihilated; "" if not
1063 # _dep_xvisits non-negative integer number of excess visits (often 0)
1065 # CMD may use a "return" statement without issue; its return value is ignored,
1066 # but if CMD sets _ret to a negative value, e.g. "-0" or "-1" the enumeration
1067 # will stop immediately and the value with the leading "-" stripped off will
1068 # be the final result code
1070 # CMD can refer to $_name for queried branch name,
1071 # $_dep for dependency name,
1072 # $_depchain for space-seperated branch backtrace,
1073 # $_dep_missing boolean to check whether $_dep is present
1074 # and the $_dep_is_tgish and $_dep_annihilated booleans.
1075 # If recurse_preorder is NOT set then the $_dep_is_leaf boolean is also valid.
1076 # It can modify $_ret to affect the return value
1077 # of the whole function.
1078 # If recurse_deps() hits missing dependencies, it will append
1079 # them to space-separated $missing_deps list and skip them
1080 # after calling CMD with _dep_missing set.
1081 # remote dependencies are processed if no_remotes is unset.
1082 # any branch names in the space-separated recurse_deps_exclude variable
1083 # are skipped (along with their dependencies)
1085 # If no_remotes is non-empty, exclude remotes
1086 # If recurse_preorder is non-empty, do a preorder rather than postorder traversal
1087 # If with_top_level is non-empty, include the top-level that's normally omitted
1088 # any branch names in the space-separated recurse_deps_exclude variable
1089 # are skipped (along with their dependencies)
1090 recurse_deps()
1092 _opts=
1093 case "$1" in -o=*) _opts="${1#-o=}"; shift; esac
1094 _cmd="$1"; shift
1096 _depsfile="$(get_temp tg-depsfile)"
1097 eval recurse_deps_internal "$_opts" -- '"$@"' >"$_depsfile" || :
1099 _ret=0
1100 while read _ismissing _istgish _isleaf _dep_xvisits _dep _name _deppath; do
1101 _depchain="$_name${_deppath:+ $_deppath}"
1102 _dep_is_tgish=
1103 [ "$_istgish" = "0" ] || _dep_is_tgish=1
1104 _dep_has_remote=
1105 [ "$_istgish" != "2" ] || _dep_has_remote=1
1106 _dep_missing=
1107 if [ "$_ismissing" != "0" ]; then
1108 _dep_missing=1
1109 case " $missing_deps " in *" $_dep "*);;*)
1110 missing_deps="${missing_deps:+$missing_deps }$_dep"
1111 esac
1113 _dep_annihilated=
1114 _dep_is_leaf=
1115 if [ "$_isleaf" = "1" ]; then
1116 _dep_is_leaf=1
1117 elif [ "$_isleaf" = "2" ]; then
1118 _dep_annihilated=1
1120 do_eval "$_cmd" || :
1121 if [ "${_ret#-}" != "$_ret" ]; then
1122 _ret="${_ret#-}"
1123 break
1125 done <"$_depsfile"
1126 rm -f "$_depsfile"
1127 return ${_ret:-0}
1130 # find_leaves NAME
1131 # output (one per line) the unique leaves of NAME
1132 # a leaf is either
1133 # 1) a non-tgish dependency
1134 # 2) the base of a tgish dependency with no non-annihilated dependencies
1135 # duplicates are suppressed (by commit rev) and remotes are always ignored
1136 # if a leaf has an exact tag match that will be output
1137 # note that recurse_deps_exclude IS honored for this operation
1138 find_leaves()
1140 no_remotes=1
1141 with_top_level=1
1142 recurse_preorder=
1143 seen_leaf_refs=
1144 seen_leaf_revs=
1145 while read _ismissing _istgish _isleaf _dep _name _deppath; do
1146 [ "$_isleaf" = "1" ] && [ "$_ismissing" = "0" ] || continue
1147 if [ "$_istgish" != "0" ]; then
1148 fulldep="refs/$topbases/$_dep"
1149 else
1150 fulldep="refs/heads/$_dep"
1152 case " $seen_leaf_refs " in *" $fulldep "*);;*)
1153 seen_leaf_refs="${seen_leaf_refs:+$seen_leaf_refs }$fulldep"
1154 if fullrev="$(ref_exists_rev "$fulldep")"; then
1155 case " $seen_leaf_revs " in *" $fullrev "*);;*)
1156 seen_leaf_revs="${seen_leaf_revs:+$seen_leaf_revs }$fullrev"
1157 # See if Git knows it by another name
1158 if tagname="$(git describe --exact-match "$fullrev" 2>/dev/null)" && [ -n "$tagname" ]; then
1159 echo "refs/tags/$tagname"
1160 else
1161 echo "$fulldep"
1163 esac
1165 esac
1166 done <<-EOT
1167 $(recurse_deps_internal -l -o=1 -- "$1")
1169 with_top_level=
1172 # branch_needs_update
1173 # This is a helper function for determining whether given branch
1174 # is up-to-date wrt. its dependencies. It expects input as if it
1175 # is called as a recurse_deps() helper.
1176 # In case the branch does need update, it will echo it together
1177 # with the branch backtrace on the output (see needs_update()
1178 # description for details) and set $_ret to non-zero.
1179 branch_needs_update()
1181 if [ -n "$_dep_missing" ]; then
1182 echo "! $_dep $_depchain"
1183 return 0
1186 if [ -n "$_dep_is_tgish" ]; then
1187 [ -z "$_dep_annihilated" ] || return 0
1189 if [ -n "$_dep_has_remote" ]; then
1190 branch_contains "refs/heads/$_dep" "refs/remotes/$base_remote/$_dep" ||
1191 echo "refs/remotes/$base_remote/$_dep $_dep $_depchain"
1193 # We want to sync with our base first and should output this before
1194 # the remote branch, but the order does not actually matter to tg-update
1195 # as it just recurses regardless, but it does matter for tg-info (which
1196 # treats out-of-date bases as though they were already merged in) so
1197 # we output the remote before the base.
1198 branch_contains "refs/heads/$_dep" "refs/$topbases/$_dep" || {
1199 echo ": $_dep $_depchain"
1200 _ret=1
1201 return
1205 if [ -n "$_name" ]; then
1206 case "$_dep" in refs/*) _fulldep="$_dep";; *) _fulldep="refs/heads/$_dep";; esac
1207 if ! branch_contains "refs/$topbases/$_name" "$_fulldep"; then
1208 # Some new commits in _dep
1209 echo "$_dep $_depchain"
1210 _ret=1
1215 # needs_update NAME
1216 # This function is recursive; it outputs reverse path from NAME
1217 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
1218 # inner paths first. Innermost name can be refs/remotes/<remote>/<name>
1219 # if the head is not in sync with the <remote> branch <name>, ':' if
1220 # the head is not in sync with the base (in this order of priority)
1221 # or '!' if dependency is missing. Note that the remote branch, base
1222 # order is reversed from the order they will actually be updated in
1223 # order to accomodate tg info which treats out-of-date items that are
1224 # only in the base as already being in the head for status purposes.
1225 # It will also return non-zero status if NAME needs update.
1226 # If needs_update() hits missing dependencies, it will append
1227 # them to space-separated $missing_deps list and skip them.
1228 needs_update()
1230 recurse_deps branch_needs_update "$1"
1233 # append second arg to first arg variable gluing with space if first already set
1234 vplus()
1236 eval "$1=\"\${$1:+\$$1 }\$2\""
1239 # true if whitespace separated first var name list contains second arg
1240 # use `vcontains 3 "value" "some list"` for a literal list
1241 vcontains()
1243 eval case "\" \${$1} \"" in '*" $2 "*) return 0; esac; return 1'
1246 # if the $1 var does not already contain $2 it's appended
1247 vsetadd()
1249 vcontains "$1" "$2" || vplus "$1" "$2"
1252 # reset needs_update_check results to empty
1253 needs_update_check_clear()
1255 unset_ needs_update_processed needs_update_behind needs_update_ahead needs_update_partial
1258 # needs_update_check NAME...
1259 # A faster version of needs_update that always succeeds
1260 # No output and unsuitable for actually performing updates themselves
1262 # Note that results are cumulative and "no_remotes" is honored as well as other
1263 # variables that modify recurse_deps_internal behavior. See the preceding
1264 # function to reset the results to empty when accumulation should start over.
1266 # The following whitespace-separated lists are updated with the results:
1268 # The "no_remotes" setting is obeyed but remote names themselves will never
1269 # appear in any of the lists
1271 # needs_update_processed
1272 # The branch names in here have been processed and will be skipped
1274 # needs_update_behind
1275 # Any branch named in here needs an update from one or more of its
1276 # direct or indirect dependencies (i.e. it's "out-of-date")
1278 # needs_update_ahead
1279 # Any branch named in here is NOT fully contained by at least one of
1280 # its dependents (i.e. it's a source of "out-of-date (aka dirty)"ness
1282 # needs_update_partial
1283 # Any branch names in here are either missing themselves or have one
1284 # or more detected missing dependencies (a completely missing remote
1285 # branch is never "detected")
1286 needs_update_check()
1288 # each head must be processed independently or else there will be
1289 # confusion about who's missing what and which branches actually are
1290 # out of date
1291 tmptgrdi="$tg_tmp_dir/tgrdi.$$"
1292 for nucname in "$@"; do
1293 ! vcontains needs_update_processed "$nucname" || continue
1294 # no need to fuss with recurse_deps, just use
1295 # recurse_deps_internal directly
1296 recurse_deps_internal -s -o=-1 "$nucname" >"$tmptgrdi"
1297 while read -r _rdi_m _rdi_t _rdi_l _rdi_v _rdi_node _rdi_parent _rdi_chain; do
1298 [ -n "$_rdi_node" ] || continue
1299 vsetadd needs_update_processed "$_rdi_node"
1300 if [ "$_rdi_m" != "0" ]; then # missing
1301 vsetadd needs_update_partial "$_rdi_node"
1302 [ -z "$_rdi_parent" ] || vsetadd needs_update_partial "$_rdi_parent"
1303 continue
1305 [ -n "$_rdi_parent" ] || continue # a "self" line
1306 [ "$_rdi_t$_rdi_l" != "12" ] || continue # annihilated
1307 ! vcontains needs_update_partial "$_rdi_node" || vsetadd needs_update_partial "$_rdi_parent"
1308 _rdi_dertee= # :)
1309 if vcontains needs_update_behind "$_rdi_node"; then
1310 _rdi_dertee=1
1311 else
1312 if [ "$_rdi_t" != "0" ]; then # tgish
1313 if branch_contains "refs/heads/$_rdi_node" "refs/$topbases/$_rdi_node"; then
1314 if [ "$_rdi_t" = "2" ]; then # will never be "2" when no_remotes is set
1315 branch_contains "refs/heads/$_rdi_node" "refs/remotes/$base_remote/$_rdi_node" ||
1316 _rdi_dertee=1
1318 else
1319 _rdi_dertee=1
1322 [ -z "$_rdi_dertee" ] || vsetadd needs_update_behind "$_rdi_node"
1324 case "$_rdi_node" in refs/*) _rdi_full="$_rdi_node";; *) _rdi_full="refs/heads/$_rdi_node";; esac
1325 if ! branch_contains "refs/$topbases/$_rdi_parent" "$_rdi_full"; then
1326 _rdi_dertee=1
1327 vsetadd needs_update_ahead "$_rdi_node"
1329 [ -z "$_rdi_dertee" ] || vsetadd needs_update_behind "$_rdi_parent"
1330 done <"$tmptgrdi"
1331 done
1334 # branch_empty NAME [-i | -w]
1335 branch_empty()
1337 if [ -z "$2" ]; then
1338 _rev="$(ref_exists_rev "refs/heads/$1")" || return 0
1339 _result=
1340 _result_rev=
1341 { read -r _result _result_rev <"$tg_cache_dir/refs/heads/$1/.mt"; } 2>/dev/null || :
1342 [ -z "$_result" -o "$_result_rev" != "$_rev" ] || return $_result
1343 _result=0
1344 [ "$(pretty_tree -t "$1" -b)" = "$(pretty_tree -t "$1" $2)" ] || _result=$?
1345 [ -d "$tg_cache_dir/refs/heads/$1" ] || mkdir -p "$tg_cache_dir/refs/heads/$1" 2>/dev/null
1346 [ ! -d "$tg_cache_dir/refs/heads/$1" ] || echo $_result $_rev >"$tg_cache_dir/refs/heads/$1/.mt"
1347 return $_result
1348 else
1349 [ "$(pretty_tree -t "$1" -b)" = "$(pretty_tree -t "$1" $2)" ]
1353 v_get_tdmopt_internal()
1355 [ -n "$1" ] && [ -n "$3" ] || return 0
1356 [ "$2" = "-i" ] || [ "$2" = "-w" ] || return 0
1357 ensure_work_tree
1358 _optval=
1359 if v_verify_topgit_branch _tghead "HEAD" -f; then
1360 if [ "$2" = "-w" ] && [ -f "$root_dir/$3" ] && [ -r "$root_dir/$3" ]; then
1361 _opthash=
1362 if _opthash="$(git hash-object -w -t blob --stdin <"$root_dir/$3")" && [ -n "$_opthash" ]; then
1363 _optval="$4\"$_tghead:$_opthash\""
1365 elif [ "$2" = "-i" ]; then
1366 if _opthash="$(git rev-parse --quiet --verify ":0:$3" --)" && [ -n "$_opthash" ]; then
1367 _optval="$4\"$_tghead:$_opthash\""
1371 eval "$1="'"$_optval"'
1374 # set var $1 to the correct -td= option for use in an eval for $2 -i or -w mode
1375 v_get_tdopt() { v_get_tdmopt_internal "$1" "$2" ".topdeps" "-td="; }
1377 # set var $1 to the correct -tm= option for use in an eval for $2 -i or -w mode
1378 v_get_tmopt() { v_get_tdmopt_internal "$1" "$2" ".topmsg" "-tm="; }
1380 # checkout_symref_full [-f] FULLREF [SEED]
1381 # Just like git checkout $iowopt -b FULLREF [SEED] except that FULLREF MUST start with
1382 # refs/ and HEAD is ALWAYS set to a symref to it and [SEED] (default is FULLREF)
1383 # MUST be a committish which if present will be used instead of current FULLREF
1384 # (and FULLREF will be updated to it as well in that case)
1385 # Any merge state is always cleared by this function
1386 # With -f it's like git checkout $iowopt -f -b FULLREF (uses read-tree --reset
1387 # instead of -m) but it will clear out any unmerged entries
1388 # As an extension, FULLREF may also be a full hash to create a detached HEAD instead
1389 checkout_symref_full()
1391 _mode=-m
1392 _head="HEAD"
1393 if [ "$1" = "-f" ]; then
1394 _mode="--reset"
1395 _head=
1396 shift
1398 _ishash=
1399 case "$1" in
1400 refs/?*)
1402 $octet20)
1403 _ishash=1
1404 [ -z "$2" ] || [ "$1" = "$2" ] ||
1405 die "programmer error: invalid checkout_symref_full \"$1\" \"$2\""
1406 set -- HEAD "$1"
1409 die "programmer error: invalid checkout_symref_full \"$1\""
1411 esac
1412 _seedrev="$(git rev-parse --quiet --verify "${2:-$1}^0" --)" ||
1413 die "invalid committish: \"${2:-$1}\""
1414 # Clear out any MERGE_HEAD kruft
1415 rm -f "$git_dir/MERGE_HEAD" || :
1416 # We have to do all the hard work ourselves :/
1417 # This is like git checkout -b "$1" "$2"
1418 # (or just git checkout "$1"),
1419 # but never creates a detached HEAD (unless $1 is a hash)
1420 git read-tree -u $_mode $_head "$_seedrev" &&
1422 [ -z "$2" ] && [ "$(git cat-file -t "$1")" = "commit" ] ||
1423 git update-ref ${_ishash:+--no-deref} "$1" "$_seedrev"
1424 } && {
1425 [ -n "$_ishash" ] || git symbolic-ref HEAD "$1"
1429 # switch_to_base NAME [SEED]
1430 switch_to_base()
1432 checkout_symref_full "refs/$topbases/$1" "$2"
1435 # run editor with arguments
1436 # the editor setting will be cached in $tg_editor (which is eval'd)
1437 # result non-zero if editor fails or GIT_EDITOR cannot be determined
1438 # just in case, noalt_setup will be in effect while the editor is running
1439 run_editor()
1441 tg_editor="$GIT_EDITOR"
1442 [ -n "$tg_editor" ] || tg_editor="$(git var GIT_EDITOR)" || return $?
1444 noalt_setup
1445 eval "$tg_editor" '"$@"'
1449 # Show the help messages.
1450 do_help()
1452 _www=
1453 if [ "$1" = "-w" ]; then
1454 _www=1
1455 shift
1457 if [ -z "$1" ] ; then
1458 # This is currently invoked in all kinds of circumstances,
1459 # including when the user made a usage error. Should we end up
1460 # providing more than a short help message, then we should
1461 # differentiate.
1462 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
1464 ## Build available commands list for help output
1466 cmds=
1467 sep=
1468 for cmd in "$TG_INST_CMDDIR"/tg-[!-]*; do
1469 ! [ -r "$cmd" ] && continue
1470 # strip directory part and "tg-" prefix
1471 cmd="${cmd##*/}"
1472 cmd="${cmd#tg-}"
1473 [ "$cmd" != "migrate-bases" ] || continue
1474 [ "$cmd" != "summary" ] || cmd="st[atus]|$cmd"
1475 cmds="$cmds$sep$cmd"
1476 sep="|"
1477 done
1479 echo "TopGit version $TG_VERSION - A different patch queue manager"
1480 echo "Usage: $tgname [-C <dir>] [-r <remote> | -u]" \
1481 "[-c <name>=<val>] [--no-pager] ($cmds) ..."
1482 echo " Or: $tgname help [-w] [<command>]"
1483 echo "Use \"$tgdisplaydir$tgname help tg\" for overview of TopGit"
1484 elif [ -r "$TG_INST_CMDDIR"/tg-$1 -o -r "$TG_INST_SHAREDIR/tg-$1.txt" ] ; then
1485 if [ -n "$_www" ]; then
1486 nohtml=
1487 if ! [ -r "$TG_INST_SHAREDIR/topgit.html" ]; then
1488 echo "${0##*/}: missing html help file:" \
1489 "$TG_INST_SHAREDIR/topgit.html" 1>&2
1490 nohtml=1
1492 if ! [ -r "$TG_INST_SHAREDIR/tg-$1.html" ]; then
1493 echo "${0##*/}: missing html help file:" \
1494 "$TG_INST_SHAREDIR/tg-$1.html" 1>&2
1495 nohtml=1
1497 if [ -n "$nohtml" ]; then
1498 echo "${0##*/}: use" \
1499 "\"${0##*/} help $1\" instead" 1>&2
1500 exit 1
1502 git web--browse -c help.browser "$TG_INST_SHAREDIR/tg-$1.html"
1503 exit
1505 output()
1507 if [ -r "$TG_INST_CMDDIR"/tg-$1 ] ; then
1508 "$TG_INST_CMDDIR"/tg-$1 -h 2>&1 || :
1509 echo
1510 elif [ "$1" = "help" ]; then
1511 echo "Usage: ${tgname:-tg} help [-w] [<command>]"
1512 echo
1513 elif [ "$1" = "status" ] || [ "$1" = "st" ]; then
1514 echo "Usage: ${tgname:-tg} @tgsthelpusage@"
1515 echo
1517 if [ -r "$TG_INST_SHAREDIR/tg-$1.txt" ] ; then
1518 cat "$TG_INST_SHAREDIR/tg-$1.txt"
1521 page output "$1"
1522 else
1523 echo "${0##*/}: no help for $1" 1>&2
1524 do_help
1525 exit 1
1529 check_status()
1531 git_state=
1532 git_remove=
1533 tg_state=
1534 tg_remove=
1535 tg_topmerge=
1536 setup_git_dir_is_bare
1537 [ -z "$git_dir_is_bare" ] || return 0
1539 if [ -e "$git_dir/MERGE_HEAD" ]; then
1540 git_state="merge"
1541 elif [ -e "$git_dir/rebase-apply/applying" ]; then
1542 git_state="am"
1543 git_remove="$git_dir/rebase-apply"
1544 elif [ -e "$git_dir/rebase-apply" ]; then
1545 git_state="rebase"
1546 git_remove="$git_dir/rebase-apply"
1547 elif [ -e "$git_dir/rebase-merge" ]; then
1548 git_state="rebase"
1549 git_remove="$git_dir/rebase-merge"
1550 elif [ -e "$git_dir/CHERRY_PICK_HEAD" ]; then
1551 git_state="cherry-pick"
1552 elif [ -e "$git_dir/BISECT_LOG" ]; then
1553 git_state="bisect"
1554 elif [ -e "$git_dir/REVERT_HEAD" ]; then
1555 git_state="revert"
1557 git_remove="${git_remove#./}"
1559 if [ -e "$git_dir/tg-update" ]; then
1560 tg_state="update"
1561 tg_remove="$git_dir/tg-update"
1562 ! [ -s "$git_dir/tg-update/merging_topfiles" ] || tg_topmerge=1
1564 tg_remove="${tg_remove#./}"
1567 # Show status information
1568 do_status()
1570 do_status_result=0
1571 do_status_verbose=
1572 do_status_help=
1573 abbrev=refs
1574 pfx=
1575 while [ $# -gt 0 ] && case "$1" in
1576 --help|-h)
1577 do_status_help=1
1578 break;;
1579 -vv)
1580 # kludge in this common bundling option
1581 abbrev=
1582 do_status_verbose=1
1583 pfx="## "
1585 --verbose|-v)
1586 [ -z "$do_status_verbose" ] || abbrev=
1587 do_status_verbose=1
1588 pfx="## "
1590 --exit-code)
1591 do_status_result=2
1594 die "unknown status argument: $1"
1596 esac; do shift; done
1597 if [ -n "$do_status_help" ]; then
1598 echo "Usage: ${tgname:-tg} @tgsthelpusage@"
1599 return
1601 check_status
1602 symref="$(git symbolic-ref --quiet HEAD)" || :
1603 headrv="$(git rev-parse --quiet --verify ${abbrev:+--short} HEAD --)" || :
1604 if [ -n "$symref" ]; then
1605 uprefpart=
1606 if [ -n "$headrv" ]; then
1607 upref="$(git rev-parse --symbolic-full-name @{upstream} 2>/dev/null)" || :
1608 if [ -n "$upref" ]; then
1609 uprefpart=" ... ${upref#$abbrev/remotes/}"
1610 mbase="$(git merge-base HEAD "$upref")" || :
1611 ahead="$(git rev-list --count HEAD ${mbase:+--not $mbase})" || ahead=0
1612 behind="$(git rev-list --count "$upref" ${mbase:+--not $mbase})" || behind=0
1613 [ "$ahead$behind" = "00" ] || uprefpart="$uprefpart ["
1614 [ "$ahead" = "0" ] || uprefpart="${uprefpart}ahead $ahead"
1615 [ "$ahead" = "0" ] || [ "$behind" = "0" ] || uprefpart="$uprefpart, "
1616 [ "$behind" = "0" ] || uprefpart="${uprefpart}behind $behind"
1617 [ "$ahead$behind" = "00" ] || uprefpart="$uprefpart]"
1620 echol "${pfx}HEAD -> ${symref#$abbrev/heads/} [${headrv:-unborn}]$uprefpart"
1621 else
1622 echol "${pfx}HEAD -> ${headrv:-?}"
1624 if [ -n "$tg_state" ]; then
1625 extra=
1626 if [ "$tg_state" = "update" ]; then
1627 IFS= read -r uname <"$git_dir/tg-update/name" || :
1628 [ -z "$uname" ] ||
1629 extra="; currently updating branch '$uname'"
1631 echol "${pfx}tg $tg_state in progress$extra"
1632 if [ -s "$git_dir/tg-update/fullcmd" ] && [ -s "$git_dir/tg-update/names" ]; then
1633 printf "${pfx}You are currently updating as a result of:\n${pfx} "
1634 cat "$git_dir/tg-update/fullcmd"
1635 bcnt="$(( $(wc -w < "$git_dir/tg-update/names") ))"
1636 if [ $bcnt -gt 1 ]; then
1637 pcnt=0
1638 ! [ -s "$git_dir/tg-update/processed" ] ||
1639 pcnt="$(( $(wc -w < "$git_dir/tg-update/processed") ))"
1640 echo "${pfx}$pcnt of $bcnt branches updated so far"
1643 if [ "$tg_state" = "update" ]; then
1644 echol "${pfx} (use \"$tgdisplayac update --continue\" to continue)"
1645 echol "${pfx} (use \"$tgdisplayac update --skip\" to skip this branch and continue)"
1646 echol "${pfx} (use \"$tgdisplayac update --stop\" to stop and retain changes so far)"
1647 echol "${pfx} (use \"$tgdisplayac update --abort\" to restore pre-update state)"
1650 [ -z "$git_state" ] || echo "${pfx}git $git_state in progress"
1651 if [ "$git_state" = "merge" ]; then
1652 ucnt="$(( $(git ls-files --unmerged --full-name --abbrev :/ | wc -l) ))"
1653 if [ $ucnt -gt 0 ]; then
1654 echo "${pfx}"'fix conflicts and then "git commit" the result'
1655 else
1656 echo "${pfx}"'all conflicts fixed; run "git commit" to record result'
1659 if [ -z "$git_state" ]; then
1660 setup_git_dir_is_bare
1661 [ -z "$git_dir_is_bare" ] || return 0
1662 gsp="$(git status --porcelain 2>/dev/null)" || return 0 # bare repository???
1663 gspcnt=0
1664 [ -z "$gsp" ] ||
1665 gspcnt="$(( $(printf '%s\n' "$gsp" | sed -n '/^??/!p' | wc -l) ))"
1666 untr=
1667 if [ "$gspcnt" -eq 0 ]; then
1668 [ -z "$gsp" ] || untr="; non-ignored, untracked files present"
1669 echo "${pfx}working directory is clean$untr"
1670 [ -n "$tg_state" ] || do_status_result=0
1671 else
1672 echo "${pfx}working directory is DIRTY"
1673 [ -z "$do_status_verbose" ] || git status --short --untracked-files=no
1678 ## Pager stuff
1680 # isatty FD
1681 isatty()
1683 test -t $1
1686 # pass "diff" to get pager.diff
1687 # if pager.$1 is a boolean false returns cat
1688 # if set to true or unset fails
1689 # otherwise succeeds and returns the value
1690 get_pager()
1692 if _x="$(git config --bool "pager.$1" 2>/dev/null)"; then
1693 [ "$_x" != "true" ] || return 1
1694 echo "cat"
1695 return 0
1697 if _x="$(git config "pager.$1" 2>/dev/null)"; then
1698 echol "$_x"
1699 return 0
1701 return 1
1704 # setup_pager
1705 # Set TG_PAGER to a valid executable
1706 # After calling, code to be paged should be surrounded with {...} | eval "$TG_PAGER"
1707 # See also the following "page" function for ease of use
1708 # emptypager will be set to 1 (otherwise empty) if TG_PAGER was set to "cat" to not be empty
1709 # Preference is (same as Git):
1710 # 1. GIT_PAGER
1711 # 2. pager.$USE_PAGER_TYPE (but only if USE_PAGER_TYPE is set and so is pager.$USE_PAGER_TYPE)
1712 # 3. core.pager (only if set)
1713 # 4. PAGER
1714 # 5. git var GIT_PAGER
1715 # 6. less
1716 setup_pager()
1718 isatty 1 || { emptypager=1; TG_PAGER=cat; return 0; }
1720 emptypager=
1721 if [ -z "$TG_PAGER_IN_USE" ]; then
1722 # TG_PAGER = GIT_PAGER | PAGER | less
1723 # NOTE: GIT_PAGER='' is significant
1724 if [ -n "${GIT_PAGER+set}" ]; then
1725 TG_PAGER="$GIT_PAGER"
1726 elif [ -n "$USE_PAGER_TYPE" ] && _dp="$(get_pager "$USE_PAGER_TYPE")"; then
1727 TG_PAGER="$_dp"
1728 elif _cp="$(git config core.pager 2>/dev/null)"; then
1729 TG_PAGER="$_cp"
1730 elif [ -n "${PAGER+set}" ]; then
1731 TG_PAGER="$PAGER"
1732 else
1733 _gp="$(git var GIT_PAGER 2>/dev/null)" || :
1734 [ "$_gp" != ":" ] || _gp=
1735 TG_PAGER="${_gp:-less}"
1737 if [ -z "$TG_PAGER" ]; then
1738 emptypager=1
1739 TG_PAGER=cat
1741 else
1742 emptypager=1
1743 TG_PAGER=cat
1746 # Set pager default environment variables
1747 # see pager.c:setup_pager
1748 if [ -z "${LESS+set}" ]; then
1749 LESS="-FRX"
1750 export LESS
1752 if [ -z "${LV+set}" ]; then
1753 LV="-c"
1754 export LV
1757 # this is needed so e.g. $(git diff) will still colorize it's output if
1758 # requested in ~/.gitconfig with color.diff=auto
1759 GIT_PAGER_IN_USE=1
1760 export GIT_PAGER_IN_USE
1762 # this is needed so we don't get nested pagers
1763 TG_PAGER_IN_USE=1
1764 export TG_PAGER_IN_USE
1767 # page eval_arg [arg ...]
1769 # Calls setup_pager then evals the first argument passing it all the rest
1770 # where the output is piped through eval "$TG_PAGER" unless emptypager is set
1771 # by setup_pager (in which case the output is left as-is).
1773 # To handle arbitrary paging duties, collect lines to be paged into a
1774 # function and then call page with the function name or perhaps func_name "$@".
1776 # If no arguments at all are passed in do nothing (return with success).
1777 page()
1779 [ $# -gt 0 ] || return 0
1780 setup_pager
1781 _evalarg="$1"; shift
1782 if [ -n "$emptypager" ]; then
1783 eval "$_evalarg" '"$@"'
1784 else
1785 { eval "$_evalarg" '"$@"';} | eval "$TG_PAGER"
1789 # get_temp NAME [-d]
1790 # creates a new temporary file (or directory with -d) in the global
1791 # temporary directory $tg_tmp_dir with pattern prefix NAME
1792 get_temp()
1794 mktemp $2 "$tg_tmp_dir/$1.XXXXXX"
1797 # automatically called by strftime
1798 # does nothing if already setup
1799 # may be called explicitly if the first call would otherwise be in a subshell
1800 # so that the setup is only done once before subshells start being spawned
1801 setup_strftime()
1803 [ -z "$strftime_is_setup" ] || return 0
1805 # date option to format raw epoch seconds values
1806 daterawopt=
1807 _testes='951807788'
1808 _testdt='2000-02-29 07:03:08 UTC'
1809 _testfm='%Y-%m-%d %H:%M:%S %Z'
1810 if [ "$(TZ=UTC date "-d@$_testes" "+$_testfm" 2>/dev/null)" = "$_testdt" ]; then
1811 daterawopt='-d@'
1812 elif [ "$(TZ=UTC date "-r$_testes" "+$_testfm" 2>/dev/null)" = "$_testdt" ]; then
1813 daterawopt='-r'
1815 strftime_is_setup=1
1818 # $1 => strftime format string to use
1819 # $2 => raw timestamp as seconds since epoch
1820 # $3 => optional time zone string (empty/absent for local time zone)
1821 strftime()
1823 setup_strftime
1824 if [ -n "$daterawopt" ]; then
1825 if [ -n "$3" ]; then
1826 TZ="$3" date "$daterawopt$2" "+$1"
1827 else
1828 date "$daterawopt$2" "+$1"
1830 else
1831 if [ -n "$3" ]; then
1832 TZ="$3" perl -MPOSIX=strftime -le 'print strftime($ARGV[0],localtime($ARGV[1]))' "$1" "$2"
1833 else
1834 perl -MPOSIX=strftime -le 'print strftime($ARGV[0],localtime($ARGV[1]))' "$1" "$2"
1839 got_cdup_result=
1840 git_cdup_result=
1841 v_get_show_cdup()
1843 if [ -z "$got_cdup_result" ]; then
1844 git_cdup_result="$(git rev-parse --show-cdup)"
1845 got_cdup_result=1
1847 [ -z "$1" ] || eval "$1="'"$git_cdup_result"'
1850 setup_git_dir_is_bare()
1852 if [ -z "$git_dir_is_bare_setup" ]; then
1853 git_dir_is_bare="$(git rev-parse --is-bare-repository)"
1854 [ z"$git_dir_is_bare" = z"true" ] || git_dir_is_bare=
1855 git_dir_is_bare_setup=1
1859 setup_git_dirs()
1861 [ -n "$git_dir" ] || git_dir="$(git rev-parse --git-dir)"
1862 if [ -n "$git_dir" ] && [ -d "$git_dir" ]; then
1863 git_dir="$(cd "$git_dir" && pwd)"
1865 if [ -z "$git_common_dir" ]; then
1866 if vcmp "$git_version" '>=' "2.5"; then
1867 # rev-parse --git-common-dir is broken and may give
1868 # an incorrect result unless the current directory is
1869 # already set to the top level directory
1870 v_get_show_cdup
1871 git_common_dir="$(cd "./$git_cdup_result" && cd "$(git rev-parse --git-common-dir)" && pwd)"
1872 else
1873 git_common_dir="$git_dir"
1876 [ -n "$git_dir" ] && [ -n "$git_common_dir" ] &&
1877 [ -d "$git_dir" ] && [ -d "$git_common_dir" ] || die "Not a git repository"
1878 git_hooks_dir="$git_common_dir/hooks"
1879 if vcmp "$git_version" '>=' "2.9" && gchp="$(git config --path --get core.hooksPath 2>/dev/null)" && [ -n "$gchp" ]; then
1880 case "$gchp" in
1881 /[!/]*)
1882 git_hooks_dir="$gchp"
1885 [ -n "$1" ] || warn "ignoring non-absolute core.hooksPath: $gchp"
1887 esac
1888 unset_ gchp
1892 basic_setup_remote()
1894 if [ -z "$base_remote" ]; then
1895 if [ "${TG_EXPLICIT_REMOTE+set}" = "set" ]; then
1896 base_remote="$TG_EXPLICIT_REMOTE"
1897 else
1898 base_remote="$(git config topgit.remote 2>/dev/null)" || :
1903 basic_setup()
1905 setup_git_dirs $1
1906 basic_setup_remote
1907 tgsequester="$(git config --bool topgit.sequester 2>/dev/null)" || :
1908 tgnosequester=
1909 [ "$tgsequester" != "false" ] || tgnosequester=1
1910 unset_ tgsequester
1912 # catch errors if topbases is used without being set
1913 unset_ tg_topbases_set
1914 topbases="programmer*:error"
1915 topbasesrx="programmer*:error}"
1916 oldbases="$topbases"
1919 ## Initial setup
1920 initial_setup()
1922 # suppress the merge log editor feature since git 1.7.10
1924 GIT_MERGE_AUTOEDIT=no
1925 export GIT_MERGE_AUTOEDIT
1927 basic_setup $1
1928 iowopt=
1929 ! vcmp "$git_version" '>=' "2.5" || iowopt="--ignore-other-worktrees"
1930 gcfbopt=
1931 ! vcmp "$git_version" '>=' "2.6" || gcfbopt="--buffer"
1932 auhopt=
1933 ! vcmp "$git_version" '>=' "2.9" || auhopt="--allow-unrelated-histories"
1934 v_get_show_cdup root_dir
1935 root_dir="${root_dir:-.}"
1936 logrefupdates="$(git config --bool core.logallrefupdates 2>/dev/null)" || :
1937 [ "$logrefupdates" = "true" ] || logrefupdates=
1939 # make sure root_dir doesn't end with a trailing slash.
1941 root_dir="${root_dir%/}"
1943 # create global temporary directories, inside GIT_DIR
1945 if [ -n "$TG_TMPDIR" ] && [ -d "$TG_TMPDIR" ] && [ -w "$TG_TMPDIR" ] &&
1946 { >"$TG_TMPDIR/.check"; } >/dev/null 2>&1; then
1947 tg_tmp_dir="$TG_TMPDIR"
1948 else
1949 tg_tmp_dir=
1950 TRAPEXIT_='${TG_DEBUG:+echo} rm -rf "$tg_tmp_dir" >&2'
1951 trap 'trapexit_ 129' HUP
1952 trap 'trapexit_ 130' INT
1953 trap 'trapexit_ 131' QUIT
1954 trap 'trapexit_ 134' ABRT
1955 trap 'trapexit_ 141' PIPE
1956 trap 'trapexit_ 143' TERM
1957 tg_tmp_dir="$(mktemp -d "$git_dir/tg-tmp.XXXXXX" 2>/dev/null)" || tg_tmp_dir=
1958 [ -n "$tg_tmp_dir" ] || tg_tmp_dir="$(mktemp -d "${TMPDIR:-/tmp}/tg-tmp.XXXXXX" 2>/dev/null)" || tg_tmp_dir=
1959 [ -n "$tg_tmp_dir" ] || [ -z "$TMPDIR" ] || tg_tmp_dir="$(mktemp -d "/tmp/tg-tmp.XXXXXX" 2>/dev/null)" || tg_tmp_dir=
1960 [ -z "$tg_tmp_dir" ] || tg_tmp_dir="$(cd "$tg_tmp_dir" && pwd -P)"
1962 unset_ TG_TMPDIR
1963 tg_ref_cache="$tg_tmp_dir/tg~ref-cache"
1964 tg_ref_cache_br="$tg_ref_cache.br"
1965 tg_ref_cache_rbr="$tg_ref_cache.rbr"
1966 tg_ref_cache_ann="$tg_ref_cache.ann"
1967 tg_ref_cache_dep="$tg_ref_cache.dep"
1968 [ -n "$tg_tmp_dir" ] && [ -w "$tg_tmp_dir" ] && { >"$tg_ref_cache"; } >/dev/null 2>&1 ||
1969 die "could not create a writable temporary directory"
1971 # make sure global cache directory exists inside GIT_DIR or $tg_tmp_dir
1973 user_id_no="$(id -u)" || :
1974 : "${user_id_no:=_99_}"
1975 tg_cache_dir="$git_common_dir/tg-cache"
1976 [ -d "$tg_cache_dir" ] || mkdir "$tg_cache_dir" >/dev/null 2>&1 || tg_cache_dir=
1977 [ -z "$tg_cache_dir" ] || tg_cache_dir="$tg_cache_dir/$user_id_no"
1978 [ -z "$tg_cache_dir" ] || [ -d "$tg_cache_dir" ] || mkdir "$tg_cache_dir" >/dev/null 2>&1 || tg_cache_dir=
1979 [ -z "$tg_cache_dir" ] || { >"$tg_cache_dir/.tgcache"; } >/dev/null 2>&1 || tg_cache_dir=
1980 if [ -z "$tg_cache_dir" ]; then
1981 tg_cache_dir="$tg_tmp_dir/tg-cache"
1982 [ -d "$tg_cache_dir" ] || mkdir "$tg_cache_dir" >/dev/null 2>&1 || tg_cache_dir=
1983 [ -z "$tg_cache_dir" ] || { >"$tg_cache_dir/.tgcache"; } >/dev/null 2>&1 || tg_cache_dir=
1985 [ -n "$tg_cache_dir" ] ||
1986 die "could not create a writable tg-cache directory (even a temporary one)"
1988 # GIT_ALTERNATE_OBJECT_DIRECTORIES can contain double-quoted entries
1989 # since Git v2.11.1; however, it's only necessary for : (or perhaps ;)
1990 # so we avoid it if possible and require v2.11.1 to do it at all
1991 # otherwise just don't make an alternates temporary store in that case;
1992 # it's okay to not have one; everything will still work; the nicety of
1993 # making the temporary tree objects vanish when tg exits just won't
1994 # happen in that case but nothing will break also be sure to reuse
1995 # the parent's if we've been recursively invoked and it's for the
1996 # same repository we were invoked on
1998 tg_use_alt_odb=1
1999 _odbdir="${GIT_OBJECT_DIRECTORY:-$git_common_dir/objects}"
2000 [ -n "$_odbdir" ] && [ -d "$_odbdir" ] || tg_use_alt_odb=
2001 _fulltmpdir=
2002 [ -z "$tg_use_alt_odb" ] || _fulltmpdir="$(cd "$tg_tmp_dir" && pwd -P)"
2003 case "$_fulltmpdir" in *[";:"]*|'"'*) vcmp "$git_version" '>=' "2.11.1" || tg_use_alt_odb=; esac
2004 _fullodbdir=
2005 [ -z "$tg_use_alt_odb" ] || _fullodbdir="$(cd "$_odbdir" && pwd -P)"
2006 if [ -n "$tg_use_alt_odb" ] && [ -n "$TG_OBJECT_DIRECTORY" ] && [ -d "$TG_OBJECT_DIRECTORY/info" ] &&
2007 [ -f "$TG_OBJECT_DIRECTORY/info/alternates" ] && [ -r "$TG_OBJECT_DIRECTORY/info/alternates" ]; then
2008 if IFS= read -r _otherodbdir <"$TG_OBJECT_DIRECTORY/info/alternates" &&
2009 [ -n "$_otherodbdir" ] && [ "$_otherodbdir" = "$_fullodbdir" ]; then
2010 tg_use_alt_odb=2
2013 if [ "$tg_use_alt_odb" = "1" ]; then
2014 # create an alternate objects database to keep the ephemeral objects in
2015 mkdir -p "$tg_tmp_dir/objects/info"
2016 echol "$_fullodbdir" >"$tg_tmp_dir/objects/info/alternates"
2017 TG_OBJECT_DIRECTORY="$_fulltmpdir/objects"
2018 case "$TG_OBJECT_DIRECTORY" in
2019 *[";:"]*|'"'*)
2020 # surround in "..." and backslash-escape internal '"' and '\\'
2021 _altodbdq="\"$(printf '%s\n' "$TG_OBJECT_DIRECTORY" |
2022 sed 's/\([""\\]\)/\\\1/g')\""
2025 _altodbdq="$TG_OBJECT_DIRECTORY"
2027 esac
2028 TG_PRESERVED_ALTERNATES="$GIT_ALTERNATE_OBJECT_DIRECTORIES"
2029 if [ -n "$GIT_ALTERNATE_OBJECT_DIRECTORIES" ]; then
2030 GIT_ALTERNATE_OBJECT_DIRECTORIES="$_altodbdq:$GIT_ALTERNATE_OBJECT_DIRECTORIES"
2031 else
2032 GIT_ALTERNATE_OBJECT_DIRECTORIES="$_altodbdq"
2034 export TG_PRESERVED_ALTERNATES TG_OBJECT_DIRECTORY GIT_ALTERNATE_OBJECT_DIRECTORIES
2035 if [ -n "$GIT_OBJECT_DIRECTORY" ]; then
2036 export GIT_OBJECT_DIRECTORY
2037 else
2038 unset_ GIT_OBJECT_DIRECTORY
2043 noalt_setup()
2045 if [ "${TG_PRESERVED_ALTERNATES+set}" = "set" ]; then
2046 GIT_ALTERNATE_OBJECT_DIRECTORIES="$TG_PRESERVED_ALTERNATES"
2047 if [ -n "$GIT_ALTERNATE_OBJECT_DIRECTORIES" ]; then
2048 export GIT_ALTERNATE_OBJECT_DIRECTORIES
2049 else
2050 unset_ GIT_ALTERNATE_OBJECT_DIRECTORIES
2053 unset_ TG_TMPDIR TG_OBJECT_DIRECTORY TG_PRESERVED_ALTERNATES tg_use_alt_odb
2056 set_topbases()
2058 # refer to "top-bases" in a refname with $topbases
2060 [ -z "$tg_topbases_set" ] || return 0
2062 topbases_implicit_default=1
2063 # See if topgit.top-bases is set to heads or refs
2064 tgtb="$(git config "topgit.top-bases" 2>/dev/null)" || :
2065 if [ -n "$tgtb" ] && [ "$tgtb" != "heads" ] && [ "$tgtb" != "refs" ]; then
2066 if [ -n "$1" ]; then
2067 # never die on the hook script
2068 unset_ tgtb
2069 else
2070 die "invalid \"topgit.top-bases\" setting (must be \"heads\" or \"refs\")"
2073 if [ -n "$tgtb" ]; then
2074 case "$tgtb" in
2075 heads)
2076 topbases="heads/{top-bases}"
2077 topbasesrx="heads/[{]top-bases[}]"
2078 oldbases="top-bases";;
2079 refs)
2080 topbases="top-bases"
2081 topbasesrx="top-bases"
2082 oldbases="heads/{top-bases}";;
2083 esac
2084 # MUST NOT be exported
2085 unset_ tgtb tg_topbases_set topbases_implicit_default
2086 tg_topbases_set=1
2087 return 0
2089 unset_ tgtb
2091 # check heads and top-bases and see what state the current
2092 # repository is in. remotes are ignored.
2094 rc=0 activebases=
2095 activebases="$(
2096 git for-each-ref --format='%(refname)' "refs/heads" "refs/top-bases" 2>/dev/null |
2097 run_awk_ref_prefixes ${1:+-e} -n -- "refs/heads/{top-bases}" "refs/top-bases" "refs/heads")" ||
2098 rc=$?
2099 if [ "$rc" = "65" ]; then
2100 # Complain and die
2101 err "repository contains existing TopGit branches"
2102 err "but some use refs/top-bases/... for the base"
2103 err "and some use refs/heads/{top-bases}/... for the base"
2104 err "with the latter being the new, preferred location"
2105 err "set \"topgit.top-bases\" to either \"heads\" to use"
2106 err "the new heads/{top-bases} location or \"refs\" to use"
2107 err "the old top-bases location."
2108 err "(the tg migrate-bases command can also resolve this issue)"
2109 die "schizophrenic repository requires topgit.top-bases setting"
2111 [ -z "$activebases" ] || unset_ topbases_implicit_default
2112 if [ "$activebases" = "refs/heads/{top-bases}" ]; then
2113 topbases="heads/{top-bases}"
2114 topbasesrx="heads/[{]top-bases[}]"
2115 oldbases="top-bases"
2116 else
2117 # default is still top-bases for now
2118 topbases="top-bases"
2119 topbasesrx="top-bases"
2120 oldbases="heads/{top-bases}"
2122 # MUST NOT be exported
2123 unset_ rc activebases tg_topases_set
2124 tg_topbases_set=1
2125 return 0
2128 # $1 is remote name to check
2129 # $2 is optional variable name to set to result of check
2130 # $3 is optional command name to use in message (defaults to $cmd)
2131 # Fatal error if remote has schizophrenic top-bases
2132 # No error (and $2, if provided, will be set to empty) if remote has no top-bases at all
2133 check_remote_topbases()
2135 [ -n "$1" ] || die "programmer error: check_remote_topbases called with no remote argument"
2136 _crrc=0 _crremotebases=
2137 _crremotebases="$(
2138 git for-each-ref --format='%(refname)' "refs/remotes/$1" 2>/dev/null |
2139 run_awk_ref_prefixes -n -- "refs/remotes/$1/{top-bases}" "refs/remotes/$1/top-bases" "refs/remotes/$1")" ||
2140 _crrc=$?
2141 if [ "$_crrc" = "65" ]; then
2142 err "remote \"$1\" has top-bases in both locations:"
2143 err " refs/remotes/$1/{top-bases}/..."
2144 err " refs/remotes/$1/top-bases/..."
2145 err "set \"topgit.top-bases\" to \"heads\" for the first, preferred location"
2146 err "or set \"topgit.top-bases\" to \"refs\" for the second, old location"
2147 err "(the \"-c topgit.top-bases=<val>\" option can be used for this)"
2148 err "then re-run the tg ${3:-$cmd} command"
2149 err "(the tg migrate-bases command can also help with this problem)"
2150 die "schizophrenic remote \"$1\" requires topgit.top-bases setting"
2152 [ "$_crrc" != "66" ] || _crremotebases= # just to be sure
2153 [ -z "$2" ] || eval "$2="'"$_crremotebases"'
2154 unset _crrc _crremotebases
2155 return 0
2158 # init_reflog "ref"
2159 # if "$logrefupdates" is set and ref is not under refs/heads/ then force
2160 # an empty log file to exist so that ref changes will be logged
2161 # "$1" must be a fully-qualified refname (i.e. start with "refs/")
2162 # However, if "$1" is "refs/tgstash" then always make the reflog
2163 # The only ref not under refs/ that Git will write a reflog for is HEAD;
2164 # no matter what, it will NOT update a reflog for any other bare refs so
2165 # just quietly succeed when passed TG_STASH without doing anything.
2166 init_reflog()
2168 [ -n "$1" ] && [ "$1" != "TG_STASH" ] || return 0
2169 [ -n "$logrefupdates" ] || [ "$1" = "refs/tgstash" ] || return 0
2170 case "$1" in refs/heads/*|HEAD) return 0;; refs/*[!/]);; *) return 1; esac
2171 mkdir -p "$git_common_dir/logs/${1%/*}" 2>/dev/null || :
2172 { >>"$git_common_dir/logs/$1" || :; } 2>/dev/null
2175 # store the "realpath" for "$2" in "$1" except the leaf is not resolved if it's
2176 # a symbolic link. The directory part must exist, but the basename need not.
2177 v_get_abs_path()
2179 [ -n "$1" ] && [ -n "$2" ] || return 1
2180 set -- "$1" "$2" "${2%/}"
2181 case "$3" in
2182 */*) set -- "$1" "$2" "${3%/*}";;
2183 * ) set -- "$1" "$2" ".";;
2184 esac
2185 case "$2" in */)
2186 set -- "$1" "${2%/}" "$3" "/"
2187 esac
2188 [ -d "$3" ] || return 1
2189 eval "$1="'"$(cd "$3" && pwd -P)/${2##*/}$4"'
2192 ## Startup
2194 : "${TG_INST_CMDDIR:=@cmddir@}"
2195 : "${TG_INST_SHAREDIR:=@sharedir@}"
2196 : "${TG_INST_HOOKSDIR:=@hooksdir@}"
2198 [ -d "$TG_INST_CMDDIR" ] ||
2199 die "No command directory: '$TG_INST_CMDDIR'"
2201 ## Include awk scripts and their utility functions (separated for easier debugging)
2203 [ -f "$TG_INST_CMDDIR/tg--awksome" ] && [ -r "$TG_INST_CMDDIR/tg--awksome" ] ||
2204 die "Missing awk scripts: '$TG_INST_CMDDIR/tg--awksome'"
2205 . "$TG_INST_CMDDIR/tg--awksome"
2207 if [ -n "$tg__include" ]; then
2209 # We were sourced from another script for our utility functions;
2210 # this is set by hooks. Skip the rest of the file. A simple return doesn't
2211 # work as expected in every shell. See http://bugs.debian.org/516188
2213 # ensure setup happens
2215 initial_setup 1
2216 set_topbases 1
2217 noalt_setup
2219 else
2221 set -e
2223 tgbin="$0"
2224 tgdir="${tgbin%/}"
2225 case "$tgdir" in */*);;*) tgdir="./$tgdir"; esac
2226 tgdir="${tgdir%/*}/"
2227 tgname="${tgbin##*/}"
2228 [ "$0" != "$tgname" ] || tgdir=""
2230 # If tg contains a '/' but does not start with one then replace it with an absolute path
2232 case "$0" in /*) ;; */*)
2233 tgdir="$(cd "${0%/*}" && pwd -P)/"
2234 tgbin="$tgdir$tgname"
2235 esac
2237 # tgdisplay will include any explicit -C <dir> etc. options whereas tgname will not
2238 # tgdisplayac is the same as tgdisplay but without any -r or -u options (ac => abort/continue)
2240 tgdisplaydir="$tgdir"
2241 tgdisplay="$tgbin"
2242 tgdisplayac="$tgdisplay"
2244 v_get_abs_path _tgnameabs "$(cmd_path "$tgname")" &&
2245 _tgabs="$_tgnameabs" &&
2246 { [ "$tgbin" = "$tgname" ] || v_get_abs_path _tgabs "$tgbin"; } &&
2247 [ "$_tgabs" = "$_tgnameabs" ]
2248 then
2249 tgdisplaydir=""
2250 tgdisplay="$tgname"
2251 tgdisplayac="$tgdisplay"
2253 [ -z "$_tgabs" ] || tgbin="$_tgabs"
2254 unset_ _tgabs _tgnameabs
2256 tg() (
2257 TG_TMPDIR="$tg_tmp_dir" && export TG_TMPDIR &&
2258 exec "$tgbin" "$@"
2261 explicit_remote=
2262 explicit_dir=
2263 gitcdopt=
2264 noremote=
2266 cmd=
2267 while :; do case "$1" in
2269 help|--help|-h)
2270 cmd=help
2271 shift
2272 break;;
2274 status|--status)
2275 cmd=status
2276 shift
2277 break;;
2279 --hooks-path)
2280 cmd=hooks-path
2281 shift
2282 break;;
2284 --exec-path)
2285 cmd=exec-path
2286 shift
2287 break;;
2289 --awk-path)
2290 cmd=awk-path
2291 shift
2292 break;;
2294 --top-bases)
2295 cmd=top-bases
2296 shift
2297 break;;
2299 --no-pager)
2300 GIT_PAGER_IN_USE=1 TG_PAGER_IN_USE=1 &&
2301 export GIT_PAGER_IN_USE TG_PAGER_IN_USE
2302 shift;;
2305 shift
2306 if [ -z "$1" ]; then
2307 echo "Option -r requires an argument." >&2
2308 do_help
2309 exit 1
2311 unset_ noremote
2312 base_remote="$1"
2313 explicit_remote="$base_remote"
2314 tgdisplay="$tgdisplaydir$tgname$gitcdopt -r $explicit_remote"
2315 TG_EXPLICIT_REMOTE="$base_remote" && export TG_EXPLICIT_REMOTE
2316 shift;;
2319 unset_ base_remote explicit_remote
2320 noremote=1
2321 tgdisplay="$tgdisplaydir$tgname$gitcdopt -u"
2322 TG_EXPLICIT_REMOTE= && export TG_EXPLICIT_REMOTE
2323 shift;;
2326 shift
2327 if [ -z "$1" ]; then
2328 echo "Option -C requires an argument." >&2
2329 do_help
2330 exit 1
2332 cd "$1"
2333 unset_ GIT_DIR GIT_COMMON_DIR
2334 if [ -z "$explicit_dir" ]; then
2335 explicit_dir="$1"
2336 else
2337 explicit_dir="$PWD"
2339 gitcdopt=" -C \"$explicit_dir\""
2340 [ "$explicit_dir" != "." ] || explicit_dir="." gitcdopt=" -C ."
2341 tgdisplay="$tgdisplaydir$tgname$gitcdopt"
2342 tgdisplayac="$tgdisplay"
2343 [ -z "$explicit_remote" ] || tgdisplay="$tgdisplay -r $explicit_remote"
2344 [ -z "$noremote" ] || tgdisplay="$tgdisplay -u"
2345 shift;;
2348 shift
2349 if [ -z "$1" ]; then
2350 echo "Option -c requires an argument." >&2
2351 do_help
2352 exit 1
2354 param="'$(printf '%s\n' "$1" | sed "s/[']/'\\\\''/g")'"
2355 GIT_CONFIG_PARAMETERS="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }$param"
2356 export GIT_CONFIG_PARAMETERS
2357 shift;;
2360 shift
2361 break;;
2364 echo "Invalid option $1 (subcommand options must appear AFTER the subcommand)." >&2
2365 do_help
2366 exit 1;;
2369 break;;
2371 esac; done
2373 [ -n "$cmd" -o $# -lt 1 ] || { cmd="$1"; shift; }
2375 ## Dispatch
2377 [ -n "$cmd" ] || { do_help; exit 1; }
2379 case "$cmd" in
2381 help)
2382 do_help "$@"
2383 exit 0;;
2385 status|st)
2386 unset_ base_remote
2387 basic_setup
2388 set_topbases
2389 do_status "$@"
2390 exit ${do_status_result:-0};;
2392 hooks-path)
2393 # Internal command
2394 echol "$TG_INST_HOOKSDIR";;
2396 exec-path)
2397 # Internal command
2398 echol "$TG_INST_CMDDIR";;
2400 awk-path)
2401 # Internal command
2402 echol "$TG_INST_CMDDIR/awk";;
2404 top-bases)
2405 # Maintenance command
2406 do_topbases_help=
2407 show_remote_topbases=
2408 case "$1" in
2409 --help|-h)
2410 do_topbases_help=0;;
2411 -r|--remote)
2412 if [ $# -eq 2 ] && [ -n "$2" ]; then
2413 # unadvertised, but make it work
2414 base_remote="$2"
2415 shift
2417 show_remote_topbases=1;;
2419 [ $# -eq 0 ] || do_topbases_help=1;;
2420 esac
2421 [ $# -le 1 ] || do_topbases_help=1
2422 if [ -n "$do_topbases_help" ]; then
2423 helpcmd='echo "Usage: ${tgname:-tg} [-r <remote>] --top-bases [-r]"'
2424 [ $do_topbases_help -eq 0 ] || helpcmd="$helpcmd >&2"
2425 eval "$helpcmd"
2426 exit $do_topbases_help
2428 git_dir=
2429 ! git_dir="$(git rev-parse --git-dir 2>&1)" || setup_git_dirs
2430 set_topbases
2431 if [ -n "$show_remote_topbases" ]; then
2432 basic_setup_remote
2433 [ -n "$base_remote" ] ||
2434 die "no remote location given. Either use -r <remote> option or set topgit.remote"
2435 rbases=
2436 [ -z "$topbases_implicit_default" ] ||
2437 check_remote_topbases "$base_remote" rbases "--top-bases"
2438 if [ -n "$rbases" ]; then
2439 echol "$rbases"
2440 else
2441 echol "refs/remotes/$base_remote/${topbases#heads/}"
2443 else
2444 echol "refs/$topbases"
2445 fi;;
2448 isutil=
2449 case "$cmd" in index-merge-one-file)
2450 isutil="-"
2451 esac
2452 [ -r "$TG_INST_CMDDIR"/tg-$isutil$cmd ] || {
2453 looplevel="$TG_ALIAS_DEPTH"
2454 [ "${looplevel#[1-9]}" != "$looplevel" ] &&
2455 [ "${looplevel%%[!0-9]*}" = "$looplevel" ] ||
2456 looplevel=0
2457 tgalias="$(git config "topgit.alias.$cmd" 2>/dev/null)" || :
2458 [ -n "$tgalias" ] || {
2459 echo "Unknown subcommand: $cmd" >&2
2460 do_help
2461 exit 1
2463 looplevel=$(( $looplevel + 1 ))
2464 [ $looplevel -le 10 ] || die "topgit.alias nesting level 10 exceeded"
2465 TG_ALIAS_DEPTH="$looplevel"
2466 export TG_ALIAS_DEPTH
2467 if [ "!${tgalias#?}" = "$tgalias" ]; then
2468 unset_ GIT_PREFIX
2469 if pfx="$(git rev-parse --show-prefix 2>/dev/null)"; then
2470 GIT_PREFIX="$pfx"
2471 export GIT_PREFIX
2473 cd "./$(git rev-parse --show-cdup 2>/dev/null)"
2474 exec @SHELL_PATH@ -c "${tgalias#?} \"\$@\"" @SHELL_PATH@ "$@"
2475 else
2476 eval 'exec "$tgbin"' "$tgalias" '"$@"'
2478 die "alias execution failed for: $tgalias"
2480 unset_ TG_ALIAS_DEPTH
2482 showing_help=
2483 if [ "$*" = "-h" ] || [ "$*" = "--help" ]; then
2484 showing_help=1
2487 [ -n "$showing_help" ] || initial_setup
2488 [ -z "$noremote" ] || unset_ base_remote
2490 nomergesetup="$showing_help"
2491 case "$cmd" in base|contains|files|info|log|mail|next|patch|prev|rebase|revert|summary|tag)
2492 # avoid merge setup where not necessary
2494 nomergesetup=1
2495 esac
2497 if [ -z "$nomergesetup" ]; then
2498 # make sure merging the .top* files will always behave sanely
2500 setup_ours
2501 setup_hook "pre-commit"
2504 # everything but rebase needs topbases set
2505 carefully="$showing_help"
2506 [ "$cmd" != "migrate-bases" ] || carefully=1
2507 [ "$cmd" = "rebase" ] || set_topbases $carefully
2509 _use_ref_cache=
2510 tg_read_only=1
2511 _suppress_alt=
2512 case "$cmd$showing_help" in
2513 contains|info|summary|tag)
2514 _use_ref_cache=1;;
2515 "export")
2516 _use_ref_cache=1
2517 suppress_alt=1;;
2518 annihilate|create|delete|depend|import|update)
2519 tg_read_only=
2520 suppress_alt=1;;
2521 esac
2522 [ -z "$_suppress_alt" ] || noalt_setup
2523 [ -z "$_use_ref_cache" ] || v_create_ref_cache
2525 fullcmd="${tgname:-tg} $cmd $*"
2526 . "$TG_INST_CMDDIR"/tg-$isutil$cmd;;
2527 esac